package epsilonStandalone;

import epsilonStandalone.DNIRunner;
import epsilonStandalone.ExperimentModel;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import org.eclipse.epsilon.eol.execute.context.Variable;
import org.eclipse.epsilon.eol.types.EolPrimitiveType;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IntegerRange;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure2;

@SuppressWarnings("all")
public class DNIRunner_Simutools2016 extends DNIRunner {
  public static void main(final String[] args) {
    final DNIRunner_Simutools2016 a = new DNIRunner_Simutools2016();
    a.reset();
    a.reset();
    a.start_experiment2();
    a.reset();
    a.start_experiment3_2920();
    a.reset();
    a.start_experiment3_3500();
    a.reset();
  }
  
  public String reset() {
    String _xblockexpression = null;
    {
      LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
      this.simQpnParser.interestingPlaces = _newLinkedList;
      LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
      this.simQpnParser.interestingColors = _newLinkedList_1;
      LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
      this.simQpnParser.interestingMetrics = _newLinkedList_2;
      this.dniModels.clear();
      this.qpmeModels.clear();
      this.qpmeFiles.clear();
      this.qpmeSimulationResultFiles.clear();
      this.qpmeSimulationProcessedResults.clear();
      _xblockexpression = this.dni_base_model_file = "models/scenario0A.model";
    }
    return _xblockexpression;
  }
  
  public void start_experiment1(final boolean simulate) {
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment1_";
    int i = 0;
    int param_MTUsize = 1500;
    i = 1;
    {
      String expName = (expNamePrefix + "2920_HW_92.2Mpps_128Gbps_3.3us");
      int param_SdnSwSwitchingLatency = 340;
      int param_SdnSwSwitchingperfPPS = 2000;
      boolean param_goOverSdnSW = false;
      double param_SdnHwSwitchingLatency = 3.3;
      double param_SdnHwSwitchingperfPPS = (92.2 * 1000000);
      int param_SdnHwSwitchingperfBPS = 128;
      List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
      Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
      list.add(_variable);
      Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
      list.add(_variable_1);
      Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", Integer.valueOf(param_SdnSwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_2);
      Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_3);
      Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_4);
      Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_5);
      Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Integer.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
      list.add(_variable_6);
      this.epsilonTransformationParameters.put(expName, list);
      this.generateDniModel(this.dni_base_model_file, list, i, expName);
    }
    {
      String expName = (expNamePrefix + "2920_SW_2Kpps_128Gbps_340us");
      int param_SdnSwSwitchingLatency = 340;
      int param_SdnSwSwitchingperfPPS = 2000;
      boolean param_goOverSdnSW = true;
      double param_SdnHwSwitchingLatency = 3.3;
      double param_SdnHwSwitchingperfPPS = (92.2 * 1000000);
      int param_SdnHwSwitchingperfBPS = 128;
      List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
      Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
      list.add(_variable);
      Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
      list.add(_variable_1);
      Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", Integer.valueOf(param_SdnSwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_2);
      Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_3);
      Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_4);
      Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_5);
      Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Integer.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
      list.add(_variable_6);
      this.epsilonTransformationParameters.put(expName, list);
      this.generateDniModel(this.dni_base_model_file, list, i, expName);
    }
    {
      String expName = (expNamePrefix + "3500_HW_75.5Mpps_101.8Gbps_3.4us");
      int param_SdnSwSwitchingLatency = 30;
      int param_SdnSwSwitchingperfPPS = 10000;
      boolean param_goOverSdnSW = false;
      double param_SdnHwSwitchingLatency = 3.3;
      double param_SdnHwSwitchingperfPPS = ((75.7 * 1000) * 1000);
      double param_SdnHwSwitchingperfBPS = 108.1;
      List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
      Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
      list.add(_variable);
      Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
      list.add(_variable_1);
      Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", Integer.valueOf(param_SdnSwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_2);
      Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_3);
      Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_4);
      Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_5);
      Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
      list.add(_variable_6);
      this.epsilonTransformationParameters.put(expName, list);
      this.generateDniModel(this.dni_base_model_file, list, i, expName);
    }
    {
      String expName = (expNamePrefix + "3500_SW_10Kpps_101.8Gbps_30us");
      int param_SdnSwSwitchingLatency = 90;
      int param_SdnSwSwitchingperfPPS = 10000;
      boolean param_goOverSdnSW = true;
      double param_SdnHwSwitchingLatency = 3.3;
      double param_SdnHwSwitchingperfPPS = ((75.7 * 1000) * 1000);
      double param_SdnHwSwitchingperfBPS = 108.1;
      List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
      Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
      list.add(_variable);
      Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
      list.add(_variable_1);
      Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", Integer.valueOf(param_SdnSwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_2);
      Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_3);
      Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_4);
      Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_5);
      Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
      list.add(_variable_6);
      this.epsilonTransformationParameters.put(expName, list);
      this.generateDniModel(this.dni_base_model_file, list, i, expName);
    }
    {
      String expName = (expNamePrefix + "5700_HW_714.1Mpps_960Gbps_1.5us");
      int param_SdnSwSwitchingLatency = 1;
      int param_SdnSwSwitchingperfPPS = 999999999;
      boolean param_goOverSdnSW = false;
      double param_SdnHwSwitchingLatency = 1.5;
      double param_SdnHwSwitchingperfPPS = ((714.1 * 1000) * 1000);
      int param_SdnHwSwitchingperfBPS = 960;
      List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
      Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
      list.add(_variable);
      Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
      list.add(_variable_1);
      Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", Integer.valueOf(param_SdnSwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_2);
      Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_3);
      Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_4);
      Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_5);
      Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Integer.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
      list.add(_variable_6);
      this.epsilonTransformationParameters.put(expName, list);
      this.generateDniModel(this.dni_base_model_file, list, i, expName);
    }
    {
      String expName = (expNamePrefix + "5130_HW_96Mpps_960Gbps_5us");
      int param_SdnSwSwitchingLatency = 1;
      int param_SdnSwSwitchingperfPPS = 999999999;
      boolean param_goOverSdnSW = false;
      int param_SdnHwSwitchingLatency = 5;
      int param_SdnHwSwitchingperfPPS = ((96 * 1000) * 1000);
      int param_SdnHwSwitchingperfBPS = 128;
      List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
      Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
      list.add(_variable);
      Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
      list.add(_variable_1);
      Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", Integer.valueOf(param_SdnSwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_2);
      Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_3);
      Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Integer.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
      list.add(_variable_4);
      Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Integer.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
      list.add(_variable_5);
      Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Integer.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
      list.add(_variable_6);
      this.epsilonTransformationParameters.put(expName, list);
      this.generateDniModel(this.dni_base_model_file, list, i, expName);
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    if (simulate) {
      this.simulateAll();
    }
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    this.cleanup();
  }
  
  public void start_experiment2() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment2";
    LinkedList<Integer> mtus = CollectionLiterals.<Integer>newLinkedList(Integer.valueOf(1500), Integer.valueOf(1188), Integer.valueOf(888), Integer.valueOf(588), Integer.valueOf(288), Integer.valueOf(128));
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(80), Integer.valueOf(90), Integer.valueOf(100)))) {
        for (final Integer mtu : mtus) {
          {
            int _i = i;
            i = (_i + 1);
            Integer param_MTUsize = mtu;
            Integer param_SdnSwSwitchingLatency = swlatency;
            int param_SdnSwSwitchingperfPPS = (10 * 1000);
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.3;
            double param_SdnHwSwitchingperfPPS = 7.57E7;
            double param_SdnHwSwitchingperfBPS = (((101.8 * 1000) * 1000) * 1000);
            String expName = ((((((((((((expNamePrefix + ".mtu.") + param_MTUsize) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + Integer.valueOf(param_SdnSwSwitchingperfPPS)) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    this.cleanup();
  }
  
  public void start_experiment3_3500() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment3_3500_";
    IntegerRange _upTo = new IntegerRange(1, 100);
    final Function1<Integer, Integer> _function = (Integer v) -> {
      return Integer.valueOf(((v).intValue() * 100));
    };
    Iterable<Integer> ppsList = IterableExtensions.<Integer, Integer>map(_upTo, _function);
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(0)))) {
        for (final Integer pps : ppsList) {
          {
            int _i = i;
            i = (_i + 1);
            int param_MTUsize = 1500;
            Integer param_SdnSwSwitchingLatency = swlatency;
            Integer param_SdnSwSwitchingperfPPS = pps;
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.4;
            double param_SdnHwSwitchingperfPPS = 7.57E7;
            double param_SdnHwSwitchingperfBPS = 101.8;
            String expName = ((((((((((((expNamePrefix + ".mtu.") + Integer.valueOf(param_MTUsize)) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + param_SdnSwSwitchingperfPPS) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    final Procedure2<Object, Integer> _function_1 = (Object pair, Integer placeIndex) -> {
      ExperimentModel p = ((ExperimentModel) pair);
      String _experimentName = p.getExperimentName();
      String _plus_2 = ("EXP " + _experimentName);
      String _plus_3 = (_plus_2 + " FILE ");
      String _modelURI = p.getModelURI();
      String _plus_4 = (_plus_3 + _modelURI);
      InputOutput.<String>println(_plus_4);
    };
    IterableExtensions.<Object>forEach(this.qpmeSimulationResultFiles, _function_1);
    this.cleanup();
  }
  
  public void start_experiment3_3500_new() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment3_3500_NEW";
    IntegerRange _upTo = new IntegerRange(1, 10);
    final Function1<Integer, Integer> _function = (Integer v) -> {
      return Integer.valueOf(((v).intValue() * 1000));
    };
    Iterable<Integer> ppsList = IterableExtensions.<Integer, Integer>map(_upTo, _function);
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(70), Integer.valueOf(80), Integer.valueOf(90)))) {
        for (final Integer pps : ppsList) {
          {
            int _i = i;
            i = (_i + 1);
            int param_MTUsize = 1500;
            Integer param_SdnSwSwitchingLatency = swlatency;
            Integer param_SdnSwSwitchingperfPPS = pps;
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.4;
            double param_SdnHwSwitchingperfPPS = 7.57E7;
            double param_SdnHwSwitchingperfBPS = 101.8;
            String expName = ((((((((((((expNamePrefix + ".mtu.") + Integer.valueOf(param_MTUsize)) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + param_SdnSwSwitchingperfPPS) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    final Procedure2<Object, Integer> _function_1 = (Object pair, Integer placeIndex) -> {
      ExperimentModel p = ((ExperimentModel) pair);
      String _experimentName = p.getExperimentName();
      String _plus_2 = ("EXP " + _experimentName);
      String _plus_3 = (_plus_2 + " FILE ");
      String _modelURI = p.getModelURI();
      String _plus_4 = (_plus_3 + _modelURI);
      InputOutput.<String>println(_plus_4);
    };
    IterableExtensions.<Object>forEach(this.qpmeSimulationResultFiles, _function_1);
    this.cleanup();
  }
  
  public void start_experiment3_2920() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment3_2920_";
    IntegerRange _upTo = new IntegerRange(1, 20);
    final Function1<Integer, Integer> _function = (Integer v) -> {
      return Integer.valueOf(((v).intValue() * 100));
    };
    Iterable<Integer> ppsList = IterableExtensions.<Integer, Integer>map(_upTo, _function);
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(200), Integer.valueOf(300)))) {
        for (final Integer pps : ppsList) {
          {
            int _i = i;
            i = (_i + 1);
            int param_MTUsize = 1500;
            Integer param_SdnSwSwitchingLatency = swlatency;
            Integer param_SdnSwSwitchingperfPPS = pps;
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.3;
            double param_SdnHwSwitchingperfPPS = (92.2 * 1000000);
            int param_SdnHwSwitchingperfBPS = 128;
            String expName = ((((((((((((expNamePrefix + ".mtu.") + Integer.valueOf(param_MTUsize)) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + param_SdnSwSwitchingperfPPS) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Integer.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    final Procedure2<Object, Integer> _function_1 = (Object pair, Integer placeIndex) -> {
      ExperimentModel p = ((ExperimentModel) pair);
      String _experimentName = p.getExperimentName();
      String _plus_2 = ("EXP " + _experimentName);
      String _plus_3 = (_plus_2 + " FILE ");
      String _modelURI = p.getModelURI();
      String _plus_4 = (_plus_3 + _modelURI);
      InputOutput.<String>println(_plus_4);
    };
    IterableExtensions.<Object>forEach(this.qpmeSimulationResultFiles, _function_1);
    this.cleanup();
  }
}
