package epsilonStandalone;

import epsilonStandalone.DNIRunner;
import epsilonStandalone.ExperimentModel;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import org.eclipse.epsilon.eol.execute.context.Variable;
import org.eclipse.epsilon.eol.types.EolPrimitiveType;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.InputOutput;

@SuppressWarnings("all")
public class DNIRunner_mk extends DNIRunner {
  public static void main(final String[] args) {
    final DNIRunner_mk a = new DNIRunner_mk();
    a.reset();
    a.model_generation_3(false);
  }
  
  public String reset() {
    String _xblockexpression = null;
    {
      LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("SW35_i_SW01_rx");
      this.simQpnParser.interestingPlaces = _newLinkedList;
      LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Traffic_");
      this.simQpnParser.interestingColors = _newLinkedList_1;
      LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
      this.simQpnParser.interestingMetrics = _newLinkedList_2;
      this.dniModels.clear();
      this.qpmeModels.clear();
      this.qpmeFiles.clear();
      this.qpmeSimulationResultFiles.clear();
      this.qpmeSimulationProcessedResults.clear();
      _xblockexpression = this.dni_base_model_file = "models/scenario1A_01.model";
    }
    return _xblockexpression;
  }
  
  public void model_generation_1A(final boolean simulate) {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("SW35_i_SW01_rx");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Traffic_send");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    String finalResult = "";
    String expNamePrefix = "Experiment-1A";
    this.dni_base_model_file = "models/scenario1A_14_08.model";
    int i = 0;
    for (final Integer param_num_clients_1A : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(35)))) {
      {
        String expName = (((expNamePrefix + ".clients.") + param_num_clients_1A) + ".zzz");
        List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
        Variable _variable = new Variable("param_num_clients_1A", param_num_clients_1A, EolPrimitiveType.Integer);
        list.add(_variable);
        this.epsilonTransformationParameters.put(expName, list);
        ExperimentModel pairExpNameDniModel = this.stateless_applyEolStriptToBaseModel(this.dni_base_model_file, "eol/scenario1_auto_gen.eol", list, i, expName);
        this.dniModels.add(pairExpNameDniModel);
        i = (i + 1);
      }
    }
    this.checkDniModels();
    for (final Object dniURI : this.dniModels) {
      {
        String experimentName = ((ExperimentModel) dniURI).getExperimentName();
        String modelURI = ((ExperimentModel) dniURI).getModelURI();
        List<Variable> origParameterList = this.epsilonTransformationParameters.get(experimentName);
        String outFileName = (experimentName + ".qpmemodel");
        String destinationModelURI = ((this.pwdURI + this.qpmeModelsDirRelative) + outFileName);
        String qpmeResultURI = this.stateless_applyEtlStript("DNI", modelURI, "models/dnimm3.ecore", 
          "QPME", destinationModelURI, "models/qpme.ecore", 
          "etl/standalone-DNI-QPN.etl", origParameterList, experimentName);
        ExperimentModel _experimentModel = new ExperimentModel(experimentName, qpmeResultURI);
        this.qpmeModels.add(_experimentModel);
      }
    }
    this.generateQpeFiles();
    this.transformAll();
    this.cleanup();
  }
  
  public void model_generation_1B_hw(final boolean simulate) {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("SW35_i_SW01_rx");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Traffic_send");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    String finalResult = "";
    String expNamePrefix = "Experiment-1B-hw";
    this.dni_base_model_file = "models/scenario1B_base_hw_same_as_normal.model";
    int i = 0;
    for (final Integer param_num_clients_1B : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(1)))) {
      {
        String expName = (((expNamePrefix + ".clients.") + param_num_clients_1B) + ".zzz");
        List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
        Variable _variable = new Variable("param_num_clients_1B", param_num_clients_1B, EolPrimitiveType.Integer);
        list.add(_variable);
        this.epsilonTransformationParameters.put(expName, list);
        ExperimentModel pairExpNameDniModel = this.stateless_applyEolStriptToBaseModel(this.dni_base_model_file, "eol/scenario1B_auto_gen.eol", list, i, expName);
        this.dniModels.add(pairExpNameDniModel);
        i = (i + 1);
      }
    }
    this.checkDniModels();
    this.cleanup();
  }
  
  public void model_generation_1B_sw(final boolean simulate) {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("SW35_i_SW01_rx");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Traffic_send");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    String finalResult = "";
    String expNamePrefix = "Experiment-1B-sw";
    this.dni_base_model_file = "models/scenario1B_base_sw_same_as_normal.model";
    int i = 0;
    for (final Integer param_num_clients_1B : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(3)))) {
      {
        String expName = (((expNamePrefix + ".clients.") + param_num_clients_1B) + ".zzz");
        List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
        Variable _variable = new Variable("param_num_clients_1B", param_num_clients_1B, EolPrimitiveType.Integer);
        list.add(_variable);
        this.epsilonTransformationParameters.put(expName, list);
        ExperimentModel pairExpNameDniModel = this.stateless_applyEolStriptToBaseModel(this.dni_base_model_file, "eol/scenario1B_auto_gen.eol", list, i, expName);
        this.dniModels.add(pairExpNameDniModel);
        i = (i + 1);
      }
    }
    this.checkDniModels();
    this.cleanup();
  }
  
  public void model_generation_3(final boolean simulate) {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("SW35_i_SW01_rx");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Traffic_send");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    String finalResult = "";
    String expNamePrefix = "Experiment-3";
    this.dni_base_model_file = "models/Experiment-3.clients.1.zzz.dnimm3";
    int i = 0;
    for (final Integer param_num_clients_3 : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(35)))) {
      {
        String expName = (((expNamePrefix + ".clients.") + param_num_clients_3) + ".zzz");
        List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
        Variable _variable = new Variable("param_num_clients_3", param_num_clients_3, EolPrimitiveType.Integer);
        list.add(_variable);
        this.epsilonTransformationParameters.put(expName, list);
        ExperimentModel pairExpNameDniModel = this.stateless_applyEolStriptToBaseModel(this.dni_base_model_file, "eol/scenario3_auto_gen.eol", list, i, expName);
        this.dniModels.add(pairExpNameDniModel);
        i = (i + 1);
      }
    }
    this.checkDniModels();
    this.cleanup();
  }
  
  public void start_experiment1(final boolean simulate) {
    String finalResult = "";
    ExperimentModel _experimentModel = new ExperimentModel("scenario1B_C39_request_from_C10_01_hw", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario1B_C39_request_from_C10_01_hw.results.xml");
    LinkedList<ExperimentModel> models = CollectionLiterals.<ExperimentModel>newLinkedList(_experimentModel);
    for (final ExperimentModel m : models) {
      {
        String experimentName = ((ExperimentModel) m).getExperimentName();
        String _modelURI = ((ExperimentModel) m).getModelURI();
        String result = this.parseResult(_modelURI, experimentName);
        String line = ((experimentName + " # ") + result);
        String _finalResult = finalResult;
        finalResult = (_finalResult + line);
        InputOutput.<String>println(line);
        this.qpmeSimulationProcessedResults.add(result);
        this.saveOutput(finalResult, (("/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/" + experimentName) + ".final"));
      }
    }
    this.cleanup();
  }
}
