package epsilonStandalone;

import org.eclipse.xtend.lib.Data;
import org.eclipse.xtext.xbase.lib.Pure;
import org.eclipse.xtext.xbase.lib.util.ToStringHelper;

@Data
@SuppressWarnings("all")
public class ExperimentModel {
  private final String _experimentName;
  
  private final String _modelURI;
  
  public ExperimentModel(final String experimentName, final String modelURI) {
    super();
    this._experimentName = experimentName;
    this._modelURI = modelURI;
  }
  
  @Override
  @Pure
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((this._experimentName== null) ? 0 : this._experimentName.hashCode());
    result = prime * result + ((this._modelURI== null) ? 0 : this._modelURI.hashCode());
    return result;
  }
  
  @Override
  @Pure
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    ExperimentModel other = (ExperimentModel) obj;
    if (this._experimentName == null) {
      if (other._experimentName != null)
        return false;
    } else if (!this._experimentName.equals(other._experimentName))
      return false;
    if (this._modelURI == null) {
      if (other._modelURI != null)
        return false;
    } else if (!this._modelURI.equals(other._modelURI))
      return false;
    return true;
  }
  
  @Override
  @Pure
  public String toString() {
    String result = new ToStringHelper().toString(this);
    return result;
  }
  
  @Pure
  public String getExperimentName() {
    return this._experimentName;
  }
  
  @Pure
  public String getModelURI() {
    return this._modelURI;
  }
}
