/**
 */
package DNImaster.impl;

import DNImaster.ElementWithPerformance;
import DNImaster.EntityAddress;
import DNImaster.MasterPackage;
import DNImaster.ProtocolStack;
import DNImaster.VirtualNetworkInterface;
import DNImaster.VirtualNetworkInterfacePerfSpec;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Virtual Network Interface</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link DNImaster.impl.VirtualNetworkInterfaceImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNetworkInterfaceImpl#getAlternativeNames <em>Alternative Names</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNetworkInterfaceImpl#getName <em>Name</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNetworkInterfaceImpl#getAddresses <em>Addresses</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNetworkInterfaceImpl#getPerformance <em>Performance</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNetworkInterfaceImpl#getUsedProtocolStack <em>Used Protocol Stack</em>}</li>
 * </ul>
 *
 * @generated
 */
public class VirtualNetworkInterfaceImpl extends MinimalEObjectImpl.Container implements VirtualNetworkInterface {
	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAlternativeNames() <em>Alternative Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternativeNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> alternativeNames;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAddresses() <em>Addresses</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddresses()
	 * @generated
	 * @ordered
	 */
	protected EList<EntityAddress> addresses;

	/**
	 * The cached value of the '{@link #getPerformance() <em>Performance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPerformance()
	 * @generated
	 * @ordered
	 */
	protected VirtualNetworkInterfacePerfSpec performance;

	/**
	 * The cached value of the '{@link #getUsedProtocolStack() <em>Used Protocol Stack</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUsedProtocolStack()
	 * @generated
	 * @ordered
	 */
	protected ProtocolStack usedProtocolStack;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VirtualNetworkInterfaceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MasterPackage.Literals.VIRTUAL_NETWORK_INTERFACE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NETWORK_INTERFACE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAlternativeNames() {
		if (alternativeNames == null) {
			alternativeNames = new EDataTypeUniqueEList<String>(String.class, this, MasterPackage.VIRTUAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES);
		}
		return alternativeNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NETWORK_INTERFACE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EntityAddress> getAddresses() {
		if (addresses == null) {
			addresses = new EObjectContainmentEList<EntityAddress>(EntityAddress.class, this, MasterPackage.VIRTUAL_NETWORK_INTERFACE__ADDRESSES);
		}
		return addresses;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VirtualNetworkInterfacePerfSpec getPerformance() {
		return performance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPerformance(VirtualNetworkInterfacePerfSpec newPerformance, NotificationChain msgs) {
		VirtualNetworkInterfacePerfSpec oldPerformance = performance;
		performance = newPerformance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE, oldPerformance, newPerformance);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPerformance(VirtualNetworkInterfacePerfSpec newPerformance) {
		if (newPerformance != performance) {
			NotificationChain msgs = null;
			if (performance != null)
				msgs = ((InternalEObject)performance).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE, null, msgs);
			if (newPerformance != null)
				msgs = ((InternalEObject)newPerformance).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE, null, msgs);
			msgs = basicSetPerformance(newPerformance, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE, newPerformance, newPerformance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolStack getUsedProtocolStack() {
		if (usedProtocolStack != null && usedProtocolStack.eIsProxy()) {
			InternalEObject oldUsedProtocolStack = (InternalEObject)usedProtocolStack;
			usedProtocolStack = (ProtocolStack)eResolveProxy(oldUsedProtocolStack);
			if (usedProtocolStack != oldUsedProtocolStack) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK, oldUsedProtocolStack, usedProtocolStack));
			}
		}
		return usedProtocolStack;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolStack basicGetUsedProtocolStack() {
		return usedProtocolStack;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUsedProtocolStack(ProtocolStack newUsedProtocolStack) {
		ProtocolStack oldUsedProtocolStack = usedProtocolStack;
		usedProtocolStack = newUsedProtocolStack;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK, oldUsedProtocolStack, usedProtocolStack));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ADDRESSES:
				return ((InternalEList<?>)getAddresses()).basicRemove(otherEnd, msgs);
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE:
				return basicSetPerformance(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__DESCRIPTION:
				return getDescription();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES:
				return getAlternativeNames();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__NAME:
				return getName();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ADDRESSES:
				return getAddresses();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE:
				return getPerformance();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				if (resolve) return getUsedProtocolStack();
				return basicGetUsedProtocolStack();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				getAlternativeNames().addAll((Collection<? extends String>)newValue);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__NAME:
				setName((String)newValue);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ADDRESSES:
				getAddresses().clear();
				getAddresses().addAll((Collection<? extends EntityAddress>)newValue);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE:
				setPerformance((VirtualNetworkInterfacePerfSpec)newValue);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				setUsedProtocolStack((ProtocolStack)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ADDRESSES:
				getAddresses().clear();
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE:
				setPerformance((VirtualNetworkInterfacePerfSpec)null);
				return;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				setUsedProtocolStack((ProtocolStack)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ALTERNATIVE_NAMES:
				return alternativeNames != null && !alternativeNames.isEmpty();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__ADDRESSES:
				return addresses != null && !addresses.isEmpty();
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE:
				return performance != null;
			case MasterPackage.VIRTUAL_NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				return usedProtocolStack != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ElementWithPerformance.class) {
			switch (derivedFeatureID) {
				case MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE: return MasterPackage.ELEMENT_WITH_PERFORMANCE__PERFORMANCE;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ElementWithPerformance.class) {
			switch (baseFeatureID) {
				case MasterPackage.ELEMENT_WITH_PERFORMANCE__PERFORMANCE: return MasterPackage.VIRTUAL_NETWORK_INTERFACE__PERFORMANCE;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", alternativeNames: ");
		result.append(alternativeNames);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //VirtualNetworkInterfaceImpl
