/**
 */
package DNImaster.impl;

import DNImaster.ElementWithPerformance;
import DNImaster.MasterPackage;
import DNImaster.PerformanceSpecification;
import DNImaster.PhysicalNode;
import DNImaster.SoftwareComponent;
import DNImaster.VirtualNetworkInterface;
import DNImaster.VirtualNode;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Virtual Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getAlternativeNames <em>Alternative Names</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getName <em>Name</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getPerformance <em>Performance</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getSoftware <em>Software</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getInterfaces <em>Interfaces</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#isIsEndNode <em>Is End Node</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#isIsIntermediateNode <em>Is Intermediate Node</em>}</li>
 *   <li>{@link DNImaster.impl.VirtualNodeImpl#getHostedOn <em>Hosted On</em>}</li>
 * </ul>
 *
 * @generated
 */
public class VirtualNodeImpl extends MinimalEObjectImpl.Container implements VirtualNode {
	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAlternativeNames() <em>Alternative Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternativeNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> alternativeNames;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPerformance() <em>Performance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPerformance()
	 * @generated
	 * @ordered
	 */
	protected PerformanceSpecification performance;

	/**
	 * The cached value of the '{@link #getSoftware() <em>Software</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSoftware()
	 * @generated
	 * @ordered
	 */
	protected EList<SoftwareComponent> software;

	/**
	 * The cached value of the '{@link #getInterfaces() <em>Interfaces</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaces()
	 * @generated
	 * @ordered
	 */
	protected EList<VirtualNetworkInterface> interfaces;

	/**
	 * The cached setting delegate for the '{@link #isIsEndNode() <em>Is End Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsEndNode()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature.Internal.SettingDelegate IS_END_NODE__ESETTING_DELEGATE = ((EStructuralFeature.Internal)MasterPackage.Literals.NODE__IS_END_NODE).getSettingDelegate();

	/**
	 * The cached setting delegate for the '{@link #isIsIntermediateNode() <em>Is Intermediate Node</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsIntermediateNode()
	 * @generated
	 * @ordered
	 */
	protected EStructuralFeature.Internal.SettingDelegate IS_INTERMEDIATE_NODE__ESETTING_DELEGATE = ((EStructuralFeature.Internal)MasterPackage.Literals.NODE__IS_INTERMEDIATE_NODE).getSettingDelegate();

	/**
	 * The cached value of the '{@link #getHostedOn() <em>Hosted On</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHostedOn()
	 * @generated
	 * @ordered
	 */
	protected PhysicalNode hostedOn;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VirtualNodeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MasterPackage.Literals.VIRTUAL_NODE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NODE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAlternativeNames() {
		if (alternativeNames == null) {
			alternativeNames = new EDataTypeUniqueEList<String>(String.class, this, MasterPackage.VIRTUAL_NODE__ALTERNATIVE_NAMES);
		}
		return alternativeNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NODE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceSpecification getPerformance() {
		return performance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPerformance(PerformanceSpecification newPerformance, NotificationChain msgs) {
		PerformanceSpecification oldPerformance = performance;
		performance = newPerformance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NODE__PERFORMANCE, oldPerformance, newPerformance);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPerformance(PerformanceSpecification newPerformance) {
		if (newPerformance != performance) {
			NotificationChain msgs = null;
			if (performance != null)
				msgs = ((InternalEObject)performance).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.VIRTUAL_NODE__PERFORMANCE, null, msgs);
			if (newPerformance != null)
				msgs = ((InternalEObject)newPerformance).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.VIRTUAL_NODE__PERFORMANCE, null, msgs);
			msgs = basicSetPerformance(newPerformance, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NODE__PERFORMANCE, newPerformance, newPerformance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SoftwareComponent> getSoftware() {
		if (software == null) {
			software = new EObjectResolvingEList<SoftwareComponent>(SoftwareComponent.class, this, MasterPackage.VIRTUAL_NODE__SOFTWARE);
		}
		return software;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<VirtualNetworkInterface> getInterfaces() {
		if (interfaces == null) {
			interfaces = new EObjectContainmentEList<VirtualNetworkInterface>(VirtualNetworkInterface.class, this, MasterPackage.VIRTUAL_NODE__INTERFACES);
		}
		return interfaces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsEndNode() {
		return (Boolean)IS_END_NODE__ESETTING_DELEGATE.dynamicGet(this, null, 0, true, false);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsIntermediateNode() {
		return (Boolean)IS_INTERMEDIATE_NODE__ESETTING_DELEGATE.dynamicGet(this, null, 0, true, false);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalNode getHostedOn() {
		if (hostedOn != null && hostedOn.eIsProxy()) {
			InternalEObject oldHostedOn = (InternalEObject)hostedOn;
			hostedOn = (PhysicalNode)eResolveProxy(oldHostedOn);
			if (hostedOn != oldHostedOn) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.VIRTUAL_NODE__HOSTED_ON, oldHostedOn, hostedOn));
			}
		}
		return hostedOn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PhysicalNode basicGetHostedOn() {
		return hostedOn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHostedOn(PhysicalNode newHostedOn, NotificationChain msgs) {
		PhysicalNode oldHostedOn = hostedOn;
		hostedOn = newHostedOn;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NODE__HOSTED_ON, oldHostedOn, newHostedOn);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHostedOn(PhysicalNode newHostedOn) {
		if (newHostedOn != hostedOn) {
			NotificationChain msgs = null;
			if (hostedOn != null)
				msgs = ((InternalEObject)hostedOn).eInverseRemove(this, MasterPackage.PHYSICAL_NODE__HOSTS, PhysicalNode.class, msgs);
			if (newHostedOn != null)
				msgs = ((InternalEObject)newHostedOn).eInverseAdd(this, MasterPackage.PHYSICAL_NODE__HOSTS, PhysicalNode.class, msgs);
			msgs = basicSetHostedOn(newHostedOn, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.VIRTUAL_NODE__HOSTED_ON, newHostedOn, newHostedOn));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NODE__HOSTED_ON:
				if (hostedOn != null)
					msgs = ((InternalEObject)hostedOn).eInverseRemove(this, MasterPackage.PHYSICAL_NODE__HOSTS, PhysicalNode.class, msgs);
				return basicSetHostedOn((PhysicalNode)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NODE__PERFORMANCE:
				return basicSetPerformance(null, msgs);
			case MasterPackage.VIRTUAL_NODE__INTERFACES:
				return ((InternalEList<?>)getInterfaces()).basicRemove(otherEnd, msgs);
			case MasterPackage.VIRTUAL_NODE__HOSTED_ON:
				return basicSetHostedOn(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NODE__DESCRIPTION:
				return getDescription();
			case MasterPackage.VIRTUAL_NODE__ALTERNATIVE_NAMES:
				return getAlternativeNames();
			case MasterPackage.VIRTUAL_NODE__NAME:
				return getName();
			case MasterPackage.VIRTUAL_NODE__PERFORMANCE:
				return getPerformance();
			case MasterPackage.VIRTUAL_NODE__SOFTWARE:
				return getSoftware();
			case MasterPackage.VIRTUAL_NODE__INTERFACES:
				return getInterfaces();
			case MasterPackage.VIRTUAL_NODE__IS_END_NODE:
				return isIsEndNode();
			case MasterPackage.VIRTUAL_NODE__IS_INTERMEDIATE_NODE:
				return isIsIntermediateNode();
			case MasterPackage.VIRTUAL_NODE__HOSTED_ON:
				if (resolve) return getHostedOn();
				return basicGetHostedOn();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NODE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case MasterPackage.VIRTUAL_NODE__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				getAlternativeNames().addAll((Collection<? extends String>)newValue);
				return;
			case MasterPackage.VIRTUAL_NODE__NAME:
				setName((String)newValue);
				return;
			case MasterPackage.VIRTUAL_NODE__PERFORMANCE:
				setPerformance((PerformanceSpecification)newValue);
				return;
			case MasterPackage.VIRTUAL_NODE__SOFTWARE:
				getSoftware().clear();
				getSoftware().addAll((Collection<? extends SoftwareComponent>)newValue);
				return;
			case MasterPackage.VIRTUAL_NODE__INTERFACES:
				getInterfaces().clear();
				getInterfaces().addAll((Collection<? extends VirtualNetworkInterface>)newValue);
				return;
			case MasterPackage.VIRTUAL_NODE__HOSTED_ON:
				setHostedOn((PhysicalNode)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NODE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case MasterPackage.VIRTUAL_NODE__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				return;
			case MasterPackage.VIRTUAL_NODE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MasterPackage.VIRTUAL_NODE__PERFORMANCE:
				setPerformance((PerformanceSpecification)null);
				return;
			case MasterPackage.VIRTUAL_NODE__SOFTWARE:
				getSoftware().clear();
				return;
			case MasterPackage.VIRTUAL_NODE__INTERFACES:
				getInterfaces().clear();
				return;
			case MasterPackage.VIRTUAL_NODE__HOSTED_ON:
				setHostedOn((PhysicalNode)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MasterPackage.VIRTUAL_NODE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case MasterPackage.VIRTUAL_NODE__ALTERNATIVE_NAMES:
				return alternativeNames != null && !alternativeNames.isEmpty();
			case MasterPackage.VIRTUAL_NODE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MasterPackage.VIRTUAL_NODE__PERFORMANCE:
				return performance != null;
			case MasterPackage.VIRTUAL_NODE__SOFTWARE:
				return software != null && !software.isEmpty();
			case MasterPackage.VIRTUAL_NODE__INTERFACES:
				return interfaces != null && !interfaces.isEmpty();
			case MasterPackage.VIRTUAL_NODE__IS_END_NODE:
				return IS_END_NODE__ESETTING_DELEGATE.dynamicIsSet(this, null, 0);
			case MasterPackage.VIRTUAL_NODE__IS_INTERMEDIATE_NODE:
				return IS_INTERMEDIATE_NODE__ESETTING_DELEGATE.dynamicIsSet(this, null, 0);
			case MasterPackage.VIRTUAL_NODE__HOSTED_ON:
				return hostedOn != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ElementWithPerformance.class) {
			switch (derivedFeatureID) {
				case MasterPackage.VIRTUAL_NODE__PERFORMANCE: return MasterPackage.ELEMENT_WITH_PERFORMANCE__PERFORMANCE;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ElementWithPerformance.class) {
			switch (baseFeatureID) {
				case MasterPackage.ELEMENT_WITH_PERFORMANCE__PERFORMANCE: return MasterPackage.VIRTUAL_NODE__PERFORMANCE;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", alternativeNames: ");
		result.append(alternativeNames);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //VirtualNodeImpl
