package dni3toOmnetTransformation;

import OMNET.LocalType;
import OMNET.NedFile;
import OMNET.Network;
import OMNET.OMNETFactory;
import OMNET.OMNETPackage;
import OMNET.OmnetppIniFile;
import OMNET.OmnetppIniGroup;
import OMNET.OmnetppIniLine;
import OMNET.RoutingXmlFile;
import OMNET.SubModule;
import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import dnimm3.Common;
import dnimm3.CommunicatingApplication;
import dnimm3.Dnimm3Package;
import dnimm3.End;
import dnimm3.Flow;
import dnimm3.IType;
import dnimm3.NamedElement;
import dnimm3.NetworkInfrastructure;
import dnimm3.NetworkInterface;
import dnimm3.NetworkStructure;
import dnimm3.NetworkTraffic;
import dnimm3.Node;
import java.io.FileOutputStream;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class Main {
  private final static String NAME = "dni3toomnet";
  
  private final static OMNETFactory fac = OMNETFactory.eINSTANCE;
  
  private final static OMNETPackage omn = OMNETPackage.eINSTANCE;
  
  public static void main(final String[] args) {
    String fname = "minimal.dnimm3";
    int _length = args.length;
    boolean _lessThan = (_length < 1);
    if (_lessThan) {
      InputOutput.<String>println((Main.NAME + " expects a filename as its first input, see --help for more information. Continuing with default file minimal.dnimm3"));
    } else {
      String _get = args[0];
      boolean _equals = _get.equals("--help");
      if (_equals) {
        InputOutput.<String>print("TODO Help");
        return;
      } else {
        String _get_1 = args[0];
        fname = _get_1;
      }
    }
    final URI dnimm3Uri = URI.createFileURI(fname);
    final URI omnetUri = URI.createFileURI("omnet_base.omnetmodel");
    final ResourceSetImpl resourceSet = new ResourceSetImpl();
    final EPackage.Registry packageRegistry = resourceSet.getPackageRegistry();
    packageRegistry.put(OMNETPackage.eNS_URI, OMNETPackage.eINSTANCE);
    packageRegistry.put(Dnimm3Package.eNS_URI, Dnimm3Package.eINSTANCE);
    final Map<String, Object> extensionFactoryMap = Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap();
    XMIResourceFactoryImpl _xMIResourceFactoryImpl = new XMIResourceFactoryImpl();
    extensionFactoryMap.put("dnimm3", _xMIResourceFactoryImpl);
    XMIResourceFactoryImpl _xMIResourceFactoryImpl_1 = new XMIResourceFactoryImpl();
    extensionFactoryMap.put("omnetmodel", _xMIResourceFactoryImpl_1);
    final Resource dniResource = resourceSet.getResource(dnimm3Uri, true);
    final Resource omnetResource = resourceSet.getResource(omnetUri, true);
    Main.do_transformation(dniResource, omnetResource);
    XMIResourceImpl _xMIResourceImpl = new XMIResourceImpl();
    final Procedure1<XMIResourceImpl> _function = new Procedure1<XMIResourceImpl>() {
      @Override
      public void apply(final XMIResourceImpl it) {
        try {
          EList<EObject> _contents = it.getContents();
          EList<EObject> _contents_1 = omnetResource.getContents();
          EObject _get = _contents_1.get(0);
          _contents.add(_get);
          FileOutputStream _fileOutputStream = new FileOutputStream("./output_omnet.xmi");
          it.save(_fileOutputStream, null);
        } catch (Throwable _e) {
          throw Exceptions.sneakyThrow(_e);
        }
      }
    };
    ObjectExtensions.<XMIResourceImpl>operator_doubleArrow(_xMIResourceImpl, _function);
  }
  
  private static String do_transformation(final Resource dniResource, final Resource omnetResource) {
    String _xblockexpression = null;
    {
      EList<EObject> _contents = dniResource.getContents();
      EObject _get = _contents.get(0);
      final NetworkInfrastructure dniModel = ((NetworkInfrastructure) _get);
      EList<EObject> _contents_1 = omnetResource.getContents();
      EObject _get_1 = _contents_1.get(0);
      final NedFile omnetModel = ((NedFile) _get_1);
      InputOutput.<String>println("== Starting transformation ==");
      final NetworkInfrastructure dni = dniModel;
      final NedFile ned = omnetModel;
      final OmnetppIniFile ini = omnetModel.getConfig();
      OmnetppIniFile _config = omnetModel.getConfig();
      final RoutingXmlFile routingxml = _config.getRoutingconf();
      String _dataCenterName = dni.getDataCenterName();
      String _plus = ("example_" + _dataCenterName);
      String _plus_1 = (_plus + ".xml");
      routingxml.setFilename(_plus_1);
      final Network netWork = Main.fac.createNetwork();
      netWork.setName("Submodules");
      Main.createSimController(netWork);
      final LocalType global = Main.fac.createLocalType();
      global.setName("GlobalVars");
      final OmnetppIniGroup iniGroup = Main.fac.createOmnetppIniGroup();
      iniGroup.setName("General");
      TreeIterator<EObject> _allContents = dniResource.getAllContents();
      Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
      for (final EObject e : _iterable) {
        InputOutput.<EObject>println(e);
      }
      TreeIterator<EObject> _allContents_1 = dniResource.getAllContents();
      Iterable<EObject> _iterable_1 = IteratorExtensions.<EObject>toIterable(_allContents_1);
      Iterable<NamedElement> _filter = Iterables.<NamedElement>filter(_iterable_1, NamedElement.class);
      for (final NamedElement e_1 : _filter) {
        String _name = e_1.getName();
        InputOutput.<String>println(_name);
      }
      NetworkStructure _structure = dni.getStructure();
      EList<Node> _nodes = _structure.getNodes();
      final Function1<Node, Boolean> _function = new Function1<Node, Boolean>() {
        @Override
        public Boolean apply(final Node it) {
          IType _sdntype = it.getSdntype();
          return Boolean.valueOf((_sdntype instanceof Common));
        }
      };
      Iterable<Node> _filter_1 = IterableExtensions.<Node>filter(_nodes, _function);
      final Function1<Node, Node> _function_1 = new Function1<Node, Node>() {
        @Override
        public Node apply(final Node it) {
          return ((Node) it);
        }
      };
      final Iterable<Node> dniCommonNodes = IterableExtensions.<Node, Node>map(_filter_1, _function_1);
      for (final Node n : dniCommonNodes) {
        Main.parseNodes(netWork, n);
      }
      NetworkTraffic _traffic = dni.getTraffic();
      EList<CommunicatingApplication> _software = _traffic.getSoftware();
      final Function1<CommunicatingApplication, CommunicatingApplication> _function_2 = new Function1<CommunicatingApplication, CommunicatingApplication>() {
        @Override
        public CommunicatingApplication apply(final CommunicatingApplication it) {
          return ((CommunicatingApplication) it);
        }
      };
      final List<CommunicatingApplication> CommunicatingApplications = ListExtensions.<CommunicatingApplication, CommunicatingApplication>map(_software, _function_2);
      for (final CommunicatingApplication n_1 : CommunicatingApplications) {
        Main.parseCommunicatingApp(netWork, iniGroup, n_1);
      }
      NetworkTraffic _traffic_1 = dni.getTraffic();
      EList<Flow> _flows = _traffic_1.getFlows();
      final Function1<Flow, Flow> _function_3 = new Function1<Flow, Flow>() {
        @Override
        public Flow apply(final Flow it) {
          return ((Flow) it);
        }
      };
      final List<Flow> flows = ListExtensions.<Flow, Flow>map(_flows, _function_3);
      for (final Flow n_2 : flows) {
        Main.parseFlow(netWork, n_2);
      }
      EList<LocalType> _definitions = ned.getDefinitions();
      _definitions.add(((LocalType) global));
      EList<LocalType> _definitions_1 = ned.getDefinitions();
      _definitions_1.add(((Network) netWork));
      EList<OmnetppIniGroup> _sections = ini.getSections();
      _sections.add(iniGroup);
      _xblockexpression = InputOutput.<String>println("== Transformation finished ==");
    }
    return _xblockexpression;
  }
  
  private static boolean parseNodes(final Network net, final Node n) {
    boolean _xblockexpression = false;
    {
      final SubModule node = Main.fac.createSubModule();
      String _name = n.getName();
      node.setName(_name);
      EList<NetworkInterface> _interfaces = n.getInterfaces();
      final Function1<NetworkInterface, NetworkInterface> _function = new Function1<NetworkInterface, NetworkInterface>() {
        @Override
        public NetworkInterface apply(final NetworkInterface it) {
          return ((NetworkInterface) it);
        }
      };
      final List<NetworkInterface> dniInterfaces = ListExtensions.<NetworkInterface, NetworkInterface>map(_interfaces, _function);
      for (final NetworkInterface iF : dniInterfaces) {
        {
          final SubModule netIF = Main.fac.createSubModule();
          String _name_1 = iF.getName();
          netIF.setName(_name_1);
          netIF.setType("NetworkInterface");
          EList<SubModule> _submodules = net.getSubmodules();
          _submodules.add(netIF);
        }
      }
      node.setType("Node");
      EList<SubModule> _submodules = net.getSubmodules();
      _xblockexpression = _submodules.add(node);
    }
    return _xblockexpression;
  }
  
  private static boolean parseCommunicatingApp(final Network net, final OmnetppIniGroup inig, final CommunicatingApplication a) {
    boolean _xblockexpression = false;
    {
      final SubModule app = Main.fac.createSubModule();
      final OmnetppIniLine line = Main.fac.createOmnetppIniLine();
      String _name = a.getName();
      app.setName(_name);
      String _name_1 = a.getName();
      line.setNodeSelector(_name_1);
      line.setParameter("deployedOnNode");
      End _deployedOn = a.getDeployedOn();
      boolean _notEquals = (!Objects.equal(_deployedOn, null));
      if (_notEquals) {
        End _deployedOn_1 = a.getDeployedOn();
        Node _node = _deployedOn_1.getNode();
        String _name_2 = _node.getName();
        line.setValue(_name_2);
      }
      app.setType("CommunicatingApplication");
      EList<SubModule> _submodules = net.getSubmodules();
      _submodules.add(app);
      EList<OmnetppIniLine> _lines = inig.getLines();
      _xblockexpression = _lines.add(line);
    }
    return _xblockexpression;
  }
  
  private static boolean parseFlow(final Network net, final Flow f) {
    boolean _xblockexpression = false;
    {
      final SubModule dir = Main.fac.createSubModule();
      String _name = f.getName();
      dir.setName(_name);
      dir.setType("Flow");
      EList<SubModule> _submodules = net.getSubmodules();
      _xblockexpression = _submodules.add(dir);
    }
    return _xblockexpression;
  }
  
  private static boolean createSimController(final Network net) {
    boolean _xblockexpression = false;
    {
      final SubModule simCont = Main.fac.createSubModule();
      simCont.setName("SimController");
      simCont.setType("SimulationController");
      EList<SubModule> _submodules = net.getSubmodules();
      _xblockexpression = _submodules.add(simCont);
    }
    return _xblockexpression;
  }
}
