/**
 */
package tools.descartes.dni.dnimm3ap.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance;
import tools.descartes.dni.dnimm3ap.DNIAPFactory;
import tools.descartes.dni.dnimm3ap.DNIAPPackage;

/**
 * This is the item provider adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptableIntermediatePerformanceItemProvider 
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableIntermediatePerformanceItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addEntityTypePropertyDescriptor(object);
			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Entity Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addEntityTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_IAdaptableEntity_entityType_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_IAdaptableEntity_entityType_feature", "_UI_IAdaptableEntity_type"),
				 DNIAPPackage.Literals.IADAPTABLE_ENTITY__ENTITY_TYPE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_AdaptableIntermediatePerformance_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_AdaptableIntermediatePerformance_name_feature", "_UI_AdaptableIntermediatePerformance_type"),
				 DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME,
				 false,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(DNIAPPackage.Literals.ICOSTABLE__COST);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS);
			childrenFeatures.add(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns AdaptableIntermediatePerformance.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/AdaptableIntermediatePerformance"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((AdaptableIntermediatePerformance)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_AdaptableIntermediatePerformance_type") :
			getString("_UI_AdaptableIntermediatePerformance_type") + " " + label;
	}


	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(AdaptableIntermediatePerformance.class)) {
			case DNIAPPackage.ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case DNIAPPackage.ADAPTABLE_INTERMEDIATE_PERFORMANCE__COST:
			case DNIAPPackage.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY:
			case DNIAPPackage.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS:
			case DNIAPPackage.ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ICOSTABLE__COST,
				 DNIAPFactory.eINSTANCE.createInvestment()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ICOSTABLE__COST,
				 DNIAPFactory.eINSTANCE.createHandlingTime()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY,
				 DNIAPFactory.eINSTANCE.createAlternativeDependencySet()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY,
				 DNIAPFactory.eINSTANCE.createAlternativeVariableSet()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS,
				 DNIAPFactory.eINSTANCE.createAlternativeDependencySet()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS,
				 DNIAPFactory.eINSTANCE.createAlternativeVariableSet()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS,
				 DNIAPFactory.eINSTANCE.createAlternativeDependencySet()));

		newChildDescriptors.add
			(createChildParameter
				(DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS,
				 DNIAPFactory.eINSTANCE.createAlternativeVariableSet()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY ||
			childFeature == DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS ||
			childFeature == DNIAPPackage.Literals.ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return Dnimm3apEditPlugin.INSTANCE;
	}

}
