/**
 */
package tools.descartes.dni.dnimm3.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import tools.descartes.dni.dnimm3.DNIFactory;
import tools.descartes.dni.dnimm3.DNIPackage;
import tools.descartes.dni.dnimm3.PerformanceLink;

/**
 * This is the item provider adapter for a {@link tools.descartes.dni.dnimm3.PerformanceLink} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class PerformanceLinkItemProvider extends IdentifierItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceLinkItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addEntityTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Entity Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addEntityTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_PerformanceLink_entityType_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_PerformanceLink_entityType_feature", "_UI_PerformanceLink_type"),
				 DNIPackage.Literals.PERFORMANCE_LINK__ENTITY_TYPE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY);
			childrenFeatures.add(DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns PerformanceLink.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/PerformanceLink"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((PerformanceLink)object).getUid();
		return label == null || label.length() == 0 ?
			getString("_UI_PerformanceLink_type") :
			getString("_UI_PerformanceLink_type") + " " + label;
	}


	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(PerformanceLink.class)) {
			case DNIPackage.PERFORMANCE_LINK__PROPAGATION_DELAY:
			case DNIPackage.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY,
				 DNIFactory.eINSTANCE.createConstantDoubleVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY,
				 DNIFactory.eINSTANCE.createConstantLongVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY,
				 DNIFactory.eINSTANCE.createRandomVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY,
				 DNIFactory.eINSTANCE.createDiscreteFunction()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY,
				 DNIFactory.eINSTANCE.createExponentialFunction()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH,
				 DNIFactory.eINSTANCE.createConstantDoubleVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH,
				 DNIFactory.eINSTANCE.createConstantLongVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH,
				 DNIFactory.eINSTANCE.createRandomVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH,
				 DNIFactory.eINSTANCE.createDiscreteFunction()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH,
				 DNIFactory.eINSTANCE.createExponentialFunction()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == DNIPackage.Literals.PERFORMANCE_LINK__PROPAGATION_DELAY ||
			childFeature == DNIPackage.Literals.PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
