/**
 */
package tools.descartes.dni.dnimm3;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dni.dnimm3.DNIFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 *        annotation="http://www.eclipse.org/emf/2002/GenModel modelDirectory='/tools.descartes.dni.core/src' editDirectory='/tools.descartes.dni.core/src' editorDirectory='/tools.descartes.dni.core/src' fileExtensions='dni' prefix='DNI' suppressEMFTypes='true' basePackage='tools.descartes.dni'"
 *        annotation="http://www.eclipse.org/emf/2011/Xcore Pivot='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface DNIPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "dnimm3";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dni-core-metamodel-3.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "dnimm3";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DNIPackage eINSTANCE = tools.descartes.dni.dnimm3.impl.DNIPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.NamedElement <em>Named Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.NamedElement
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNamedElement()
	 * @generated
	 */
	int NAMED_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT__DESCRIPTION = 1;

	/**
	 * The number of structural features of the '<em>Named Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Named Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.IdentifierImpl <em>Identifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.IdentifierImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIdentifier()
	 * @generated
	 */
	int IDENTIFIER = 1;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER__UID = 0;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER__UID_GENERATED = 1;

	/**
	 * The number of structural features of the '<em>Identifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Identifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Entity <em>Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Entity
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEntity()
	 * @generated
	 */
	int ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__UID = IDENTIFIER__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__UID_GENERATED = IDENTIFIER__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__NAME = IDENTIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__DESCRIPTION = IDENTIFIER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_FEATURE_COUNT = IDENTIFIER_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_OPERATION_COUNT = IDENTIFIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl <em>Network Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInfrastructure()
	 * @generated
	 */
	int NETWORK_INFRASTRUCTURE = 3;

	/**
	 * The feature id for the '<em><b>Traffic</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__TRAFFIC = 0;

	/**
	 * The feature id for the '<em><b>Structure</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__STRUCTURE = 1;

	/**
	 * The feature id for the '<em><b>Configuration</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__CONFIGURATION = 2;

	/**
	 * The feature id for the '<em><b>Entity Types</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__ENTITY_TYPES = 3;

	/**
	 * The feature id for the '<em><b>Data Center Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__DATA_CENTER_NAME = 4;

	/**
	 * The feature id for the '<em><b>Meta Model Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE__META_MODEL_VERSION = 5;

	/**
	 * The number of structural features of the '<em>Network Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Network Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INFRASTRUCTURE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkStructureImpl <em>Network Structure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkStructureImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkStructure()
	 * @generated
	 */
	int NETWORK_STRUCTURE = 4;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE__NODES = 0;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE__LINKS = 1;

	/**
	 * The number of structural features of the '<em>Network Structure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Network Structure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_STRUCTURE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NodeImpl <em>Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NodeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNode()
	 * @generated
	 */
	int NODE = 5;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__INTERFACES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Sdntype</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__SDNTYPE = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Is Physical</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__IS_PHYSICAL = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Is Physical derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__IS_PHYSICAL_DERIVED = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Hosts</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__HOSTS = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Is Hosted On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__IS_HOSTED_ON = ENTITY_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>End</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__END = ENTITY_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Intermediate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__INTERMEDIATE = ENTITY_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE__ENTITY_TYPE = ENTITY_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.EndImpl <em>End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.EndImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEnd()
	 * @generated
	 */
	int END = 6;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END__UID = IDENTIFIER__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END__UID_GENERATED = IDENTIFIER__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END__PERFORMANCE = IDENTIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END__SOFTWARE = IDENTIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Node</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END__NODE = IDENTIFIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END__NAME = IDENTIFIER_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_FEATURE_COUNT = IDENTIFIER_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_OPERATION_COUNT = IDENTIFIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.IntermediateImpl <em>Intermediate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.IntermediateImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIntermediate()
	 * @generated
	 */
	int INTERMEDIATE = 7;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE__UID = IDENTIFIER__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE__UID_GENERATED = IDENTIFIER__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE__PERFORMANCE = IDENTIFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Node</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE__NODE = IDENTIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE__NAME = IDENTIFIER_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Intermediate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_FEATURE_COUNT = IDENTIFIER_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Intermediate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_OPERATION_COUNT = IDENTIFIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.LinkImpl <em>Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.LinkImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLink()
	 * @generated
	 */
	int LINK = 8;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Connects</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__CONNECTS = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__PERFORMANCE = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__NAME_GENERATED = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__ENTITY_TYPE = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.AddressableEntity <em>Addressable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.AddressableEntity
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getAddressableEntity()
	 * @generated
	 */
	int ADDRESSABLE_ENTITY = 28;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY__ADDRESSES = 0;

	/**
	 * The number of structural features of the '<em>Addressable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Addressable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESSABLE_ENTITY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl <em>Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInterface()
	 * @generated
	 */
	int NETWORK_INTERFACE = 9;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__ADDRESSES = ADDRESSABLE_ENTITY__ADDRESSES;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__NAME = ADDRESSABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__DESCRIPTION = ADDRESSABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__UID = ADDRESSABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__UID_GENERATED = ADDRESSABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Used Protocol Stack</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__USED_PROTOCOL_STACK = ADDRESSABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__PERFORMANCE = ADDRESSABLE_ENTITY_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Node</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__NODE = ADDRESSABLE_ENTITY_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Name generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__NAME_GENERATED = ADDRESSABLE_ENTITY_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE__ENTITY_TYPE = ADDRESSABLE_ENTITY_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_FEATURE_COUNT = ADDRESSABLE_ENTITY_FEATURE_COUNT + 9;

	/**
	 * The number of operations of the '<em>Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_OPERATION_COUNT = ADDRESSABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkTrafficImpl <em>Network Traffic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkTrafficImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkTraffic()
	 * @generated
	 */
	int NETWORK_TRAFFIC = 10;

	/**
	 * The feature id for the '<em><b>Flows</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC__FLOWS = 0;

	/**
	 * The feature id for the '<em><b>Software</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC__SOFTWARE = 1;

	/**
	 * The number of structural features of the '<em>Network Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Network Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_TRAFFIC_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.FlowImpl <em>Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.FlowImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFlow()
	 * @generated
	 */
	int FLOW = 11;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Source Software</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__SOURCE_SOFTWARE = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Generated Traffic</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__GENERATED_TRAFFIC = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Destination Software</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__DESTINATION_SOFTWARE = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Destination Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW__DESTINATION_ADDRESSES = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SdnControlFlowImpl <em>Sdn Control Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SdnControlFlowImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnControlFlow()
	 * @generated
	 */
	int SDN_CONTROL_FLOW = 12;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__UID = FLOW__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__UID_GENERATED = FLOW__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__NAME = FLOW__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__DESCRIPTION = FLOW__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Source Software</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__SOURCE_SOFTWARE = FLOW__SOURCE_SOFTWARE;

	/**
	 * The feature id for the '<em><b>Generated Traffic</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__GENERATED_TRAFFIC = FLOW__GENERATED_TRAFFIC;

	/**
	 * The feature id for the '<em><b>Destination Software</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__DESTINATION_SOFTWARE = FLOW__DESTINATION_SOFTWARE;

	/**
	 * The feature id for the '<em><b>Destination Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__DESTINATION_ADDRESSES = FLOW__DESTINATION_ADDRESSES;

	/**
	 * The feature id for the '<em><b>Parent Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW__PARENT_FLOW = FLOW_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sdn Control Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW_FEATURE_COUNT = FLOW_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Sdn Control Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROL_FLOW_OPERATION_COUNT = FLOW_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.FlowTrafficImpl <em>Flow Traffic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.FlowTrafficImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFlowTraffic()
	 * @generated
	 */
	int FLOW_TRAFFIC = 13;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_TRAFFIC__FLOW = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_TRAFFIC__NAME = 1;

	/**
	 * The number of structural features of the '<em>Flow Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_TRAFFIC_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Flow Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_TRAFFIC_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.GenericFlowTrafficImpl <em>Generic Flow Traffic</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.GenericFlowTrafficImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getGenericFlowTraffic()
	 * @generated
	 */
	int GENERIC_FLOW_TRAFFIC = 14;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_TRAFFIC__FLOW = FLOW_TRAFFIC__FLOW;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_TRAFFIC__NAME = FLOW_TRAFFIC__NAME;

	/**
	 * The feature id for the '<em><b>Data Size</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_TRAFFIC__DATA_SIZE = FLOW_TRAFFIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Generic Flow Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_TRAFFIC_FEATURE_COUNT = FLOW_TRAFFIC_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Generic Flow Traffic</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_FLOW_TRAFFIC_OPERATION_COUNT = FLOW_TRAFFIC_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.CommunicatingApplicationImpl <em>Communicating Application</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.CommunicatingApplicationImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getCommunicatingApplication()
	 * @generated
	 */
	int COMMUNICATING_APPLICATION = 15;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Traffic Sources</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION__TRAFFIC_SOURCES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Deployed On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION__DEPLOYED_ON = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Communicating Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Communicating Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMUNICATING_APPLICATION_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.TrafficSourceImpl <em>Traffic Source</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.TrafficSourceImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTrafficSource()
	 * @generated
	 */
	int TRAFFIC_SOURCE = 16;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Addresses</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__ADDRESSES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Workload</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__WORKLOAD = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Software Component</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE__SOFTWARE_COMPONENT = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Traffic Source</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Traffic Source</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRAFFIC_SOURCE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkConfigurationImpl <em>Network Configuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkConfigurationImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkConfiguration()
	 * @generated
	 */
	int NETWORK_CONFIGURATION = 17;

	/**
	 * The feature id for the '<em><b>Protocols And Stacks</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION__PROTOCOLS_AND_STACKS = 0;

	/**
	 * The feature id for the '<em><b>Routes</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION__ROUTES = 1;

	/**
	 * The feature id for the '<em><b>Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION__RULES = 2;

	/**
	 * The number of structural features of the '<em>Network Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Network Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_CONFIGURATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.ProtocolsRepositoryImpl <em>Protocols Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.ProtocolsRepositoryImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getProtocolsRepository()
	 * @generated
	 */
	int PROTOCOLS_REPOSITORY = 18;

	/**
	 * The feature id for the '<em><b>Stacks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY__STACKS = 0;

	/**
	 * The feature id for the '<em><b>Protocols</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY__PROTOCOLS = 1;

	/**
	 * The number of structural features of the '<em>Protocols Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Protocols Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOLS_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.ProtocolStackImpl <em>Protocol Stack</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.ProtocolStackImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getProtocolStack()
	 * @generated
	 */
	int PROTOCOL_STACK = 19;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Layers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK__LAYERS = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Protocol Stack</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Protocol Stack</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STACK_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.ProtocolLayerImpl <em>Protocol Layer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.ProtocolLayerImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getProtocolLayer()
	 * @generated
	 */
	int PROTOCOL_LAYER = 20;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Protocol</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__PROTOCOL = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Carried By</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__IS_CARRIED_BY = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Carries</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER__CARRIES = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Protocol Layer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Protocol Layer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_LAYER_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkProtocolImpl <em>Network Protocol</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkProtocolImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkProtocol()
	 * @generated
	 */
	int NETWORK_PROTOCOL = 21;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Mtu</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__MTU = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Headers Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL__HEADERS_LENGTH = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Network Protocol</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Network Protocol</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_PROTOCOL_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.RoutesRepositoryImpl <em>Routes Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.RoutesRepositoryImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getRoutesRepository()
	 * @generated
	 */
	int ROUTES_REPOSITORY = 22;

	/**
	 * The feature id for the '<em><b>Routes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY__ROUTES = 0;

	/**
	 * The feature id for the '<em><b>Flow Routes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY__FLOW_ROUTES = 1;

	/**
	 * The feature id for the '<em><b>Directions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY__DIRECTIONS = 2;

	/**
	 * The number of structural features of the '<em>Routes Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Routes Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTES_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.DirectionImpl <em>Direction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.DirectionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDirection()
	 * @generated
	 */
	int DIRECTION = 23;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>On Node</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__ON_NODE = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__FLOW = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Via</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__VIA = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__DEFAULT = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION__PROBABILITY = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Direction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Direction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIRECTION_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.FlowRouteImpl <em>Flow Route</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.FlowRouteImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFlowRoute()
	 * @generated
	 */
	int FLOW_ROUTE = 24;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Hops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__HOPS = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__FLOW = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__START = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__END = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE__PROBABILITY = ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Flow Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Flow Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOW_ROUTE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.RouteImpl <em>Route</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.RouteImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getRoute()
	 * @generated
	 */
	int ROUTE = 25;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__UID = ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__UID_GENERATED = ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__NAME = ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__DESCRIPTION = ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Hops</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__HOPS = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__START = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE__END = ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Route</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTE_OPERATION_COUNT = ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.HopImpl <em>Hop</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.HopImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getHop()
	 * @generated
	 */
	int HOP = 26;

	/**
	 * The feature id for the '<em><b>Next Hop</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP__NEXT_HOP = 0;

	/**
	 * The feature id for the '<em><b>Interfaceref</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP__INTERFACEREF = 1;

	/**
	 * The number of structural features of the '<em>Hop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Hop</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HOP_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.EntityAddressImpl <em>Entity Address</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.EntityAddressImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEntityAddress()
	 * @generated
	 */
	int ENTITY_ADDRESS = 27;

	/**
	 * The feature id for the '<em><b>Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS__ADDRESS = 0;

	/**
	 * The feature id for the '<em><b>Address Given By</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS__ADDRESS_GIVEN_BY = 1;

	/**
	 * The number of structural features of the '<em>Entity Address</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Entity Address</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_ADDRESS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Workload <em>Workload</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Workload
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getWorkload()
	 * @generated
	 */
	int WORKLOAD = 29;

	/**
	 * The number of structural features of the '<em>Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.GenericWorkloadImpl <em>Generic Workload</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.GenericWorkloadImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getGenericWorkload()
	 * @generated
	 */
	int GENERIC_WORKLOAD = 30;

	/**
	 * The feature id for the '<em><b>Actions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_WORKLOAD__ACTIONS = WORKLOAD_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Generic Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_WORKLOAD_FEATURE_COUNT = WORKLOAD_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Generic Workload</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_WORKLOAD_OPERATION_COUNT = WORKLOAD_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.AbstractAction <em>Abstract Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.AbstractAction
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getAbstractAction()
	 * @generated
	 */
	int ABSTRACT_ACTION = 31;

	/**
	 * The number of structural features of the '<em>Abstract Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ACTION_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Abstract Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_ACTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.BranchActionImpl <em>Branch Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.BranchActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getBranchAction()
	 * @generated
	 */
	int BRANCH_ACTION = 32;

	/**
	 * The feature id for the '<em><b>Intern</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_ACTION__INTERN = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Branch Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Branch Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.LoopActionImpl <em>Loop Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.LoopActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLoopAction()
	 * @generated
	 */
	int LOOP_ACTION = 33;

	/**
	 * The feature id for the '<em><b>Intern</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION__INTERN = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Num Iterations</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION__NUM_ITERATIONS = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Loop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Loop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SequenceActionImpl <em>Sequence Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SequenceActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSequenceAction()
	 * @generated
	 */
	int SEQUENCE_ACTION = 34;

	/**
	 * The feature id for the '<em><b>Intern</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_ACTION__INTERN = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sequence Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Sequence Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.StartActionImpl <em>Start Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.StartActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getStartAction()
	 * @generated
	 */
	int START_ACTION = 35;

	/**
	 * The number of structural features of the '<em>Start Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int START_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Start Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int START_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.StopActionImpl <em>Stop Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.StopActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getStopAction()
	 * @generated
	 */
	int STOP_ACTION = 36;

	/**
	 * The number of structural features of the '<em>Stop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Stop Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.TransmitActionImpl <em>Transmit Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.TransmitActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTransmitAction()
	 * @generated
	 */
	int TRANSMIT_ACTION = 37;

	/**
	 * The feature id for the '<em><b>Flow Traffic</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSMIT_ACTION__FLOW_TRAFFIC = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Transmit Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSMIT_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Transmit Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSMIT_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.WaitActionImpl <em>Wait Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.WaitActionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getWaitAction()
	 * @generated
	 */
	int WAIT_ACTION = 38;

	/**
	 * The feature id for the '<em><b>Wait Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_ACTION__WAIT_TIME = ABSTRACT_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Wait Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_ACTION_FEATURE_COUNT = ABSTRACT_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Wait Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_ACTION_OPERATION_COUNT = ABSTRACT_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.PerformanceSpecification <em>Performance Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.PerformanceSpecification
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceSpecification()
	 * @generated
	 */
	int PERFORMANCE_SPECIFICATION = 39;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SPECIFICATION__UID = IDENTIFIER__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SPECIFICATION__UID_GENERATED = IDENTIFIER__UID_GENERATED;

	/**
	 * The number of structural features of the '<em>Performance Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SPECIFICATION_FEATURE_COUNT = IDENTIFIER_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Performance Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SPECIFICATION_OPERATION_COUNT = IDENTIFIER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.PerformanceLinkImpl <em>Performance Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.PerformanceLinkImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceLink()
	 * @generated
	 */
	int PERFORMANCE_LINK = 40;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK__UID = PERFORMANCE_SPECIFICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK__UID_GENERATED = PERFORMANCE_SPECIFICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Propagation Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK__PROPAGATION_DELAY = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Max Supported Bandwidth</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK__ENTITY_TYPE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Performance Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Performance Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_LINK_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.PerformanceNetworkInterfaceImpl <em>Performance Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.PerformanceNetworkInterfaceImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceNetworkInterface()
	 * @generated
	 */
	int PERFORMANCE_NETWORK_INTERFACE = 41;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__UID = PERFORMANCE_SPECIFICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__UID_GENERATED = PERFORMANCE_SPECIFICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Is Up</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__IS_UP = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>MTU</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__MTU = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Interface Throughput</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE__ENTITY_TYPE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Performance Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Performance Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_NETWORK_INTERFACE_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SdnFlowRuleImpl <em>Sdn Flow Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SdnFlowRuleImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnFlowRule()
	 * @generated
	 */
	int SDN_FLOW_RULE = 42;

	/**
	 * The feature id for the '<em><b>Sdn Switch</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE__SDN_SWITCH = 0;

	/**
	 * The feature id for the '<em><b>Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE__FLOW = 1;

	/**
	 * The feature id for the '<em><b>Probability Hardware</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE__PROBABILITY_HARDWARE = 2;

	/**
	 * The feature id for the '<em><b>Probability Software</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE__PROBABILITY_SOFTWARE = 3;

	/**
	 * The feature id for the '<em><b>Probability Controller</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE__PROBABILITY_CONTROLLER = 4;

	/**
	 * The feature id for the '<em><b>Controller Application</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE__CONTROLLER_APPLICATION = 5;

	/**
	 * The number of structural features of the '<em>Sdn Flow Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Sdn Flow Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FLOW_RULE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SdnControllerImpl <em>Sdn Controller</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SdnControllerImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnController()
	 * @generated
	 */
	int SDN_CONTROLLER = 43;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__UID = COMMUNICATING_APPLICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__UID_GENERATED = COMMUNICATING_APPLICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__NAME = COMMUNICATING_APPLICATION__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__DESCRIPTION = COMMUNICATING_APPLICATION__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Traffic Sources</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__TRAFFIC_SOURCES = COMMUNICATING_APPLICATION__TRAFFIC_SOURCES;

	/**
	 * The feature id for the '<em><b>Deployed On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__DEPLOYED_ON = COMMUNICATING_APPLICATION__DEPLOYED_ON;

	/**
	 * The feature id for the '<em><b>Applications</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__APPLICATIONS = COMMUNICATING_APPLICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER__NODES = COMMUNICATING_APPLICATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Sdn Controller</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_FEATURE_COUNT = COMMUNICATING_APPLICATION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Sdn Controller</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_OPERATION_COUNT = COMMUNICATING_APPLICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SdnControllerApplicationImpl <em>Sdn Controller Application</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SdnControllerApplicationImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnControllerApplication()
	 * @generated
	 */
	int SDN_CONTROLLER_APPLICATION = 44;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__UID = COMMUNICATING_APPLICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__UID_GENERATED = COMMUNICATING_APPLICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__NAME = COMMUNICATING_APPLICATION__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__DESCRIPTION = COMMUNICATING_APPLICATION__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Traffic Sources</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__TRAFFIC_SOURCES = COMMUNICATING_APPLICATION__TRAFFIC_SOURCES;

	/**
	 * The feature id for the '<em><b>Deployed On</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__DEPLOYED_ON = COMMUNICATING_APPLICATION__DEPLOYED_ON;

	/**
	 * The feature id for the '<em><b>Belongs To</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__BELONGS_TO = COMMUNICATING_APPLICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__IS_DEFAULT = COMMUNICATING_APPLICATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Response Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION__RESPONSE_DELAY = COMMUNICATING_APPLICATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Sdn Controller Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION_FEATURE_COUNT = COMMUNICATING_APPLICATION_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Sdn Controller Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_CONTROLLER_APPLICATION_OPERATION_COUNT = COMMUNICATING_APPLICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.IType <em>IType</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.IType
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIType()
	 * @generated
	 */
	int ITYPE = 45;

	/**
	 * The number of structural features of the '<em>IType</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPE_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>IType</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.CommonImpl <em>Common</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.CommonImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getCommon()
	 * @generated
	 */
	int COMMON = 46;

	/**
	 * The number of structural features of the '<em>Common</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMON_FEATURE_COUNT = ITYPE_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Common</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMON_OPERATION_COUNT = ITYPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SDNImpl <em>SDN</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SDNImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSDN()
	 * @generated
	 */
	int SDN = 47;

	/**
	 * The feature id for the '<em><b>Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN__PERFORMANCE = ITYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Controller</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN__CONTROLLER = ITYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Open Flow End Point</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN__OPEN_FLOW_END_POINT = ITYPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>SDN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_FEATURE_COUNT = ITYPE_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>SDN</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_OPERATION_COUNT = ITYPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.IntermediatePerformanceImpl <em>Intermediate Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.IntermediatePerformanceImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIntermediatePerformance()
	 * @generated
	 */
	int INTERMEDIATE_PERFORMANCE = 48;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE__UID = PERFORMANCE_SPECIFICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE__UID_GENERATED = PERFORMANCE_SPECIFICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Forwarding Latency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Switching Capacity PPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE__ENTITY_TYPE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Intermediate Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Intermediate Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.EndPerformanceImpl <em>End Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.EndPerformanceImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEndPerformance()
	 * @generated
	 */
	int END_PERFORMANCE = 49;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE__UID = PERFORMANCE_SPECIFICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE__UID_GENERATED = PERFORMANCE_SPECIFICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Software Layers Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE__SOFTWARE_LAYERS_DELAY = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE__ENTITY_TYPE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>End Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>End Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.PerformanceSdnNodeImpl <em>Performance Sdn Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.PerformanceSdnNodeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceSdnNode()
	 * @generated
	 */
	int PERFORMANCE_SDN_NODE = 50;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE__UID = PERFORMANCE_SPECIFICATION__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE__UID_GENERATED = PERFORMANCE_SPECIFICATION__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Software Switching Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE__SOFTWARE_SWITCHING_PERFORMANCE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Hardware Switching Performance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE__HARDWARE_SWITCHING_PERFORMANCE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE__ENTITY_TYPE = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Performance Sdn Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE_FEATURE_COUNT = PERFORMANCE_SPECIFICATION_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Performance Sdn Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERFORMANCE_SDN_NODE_OPERATION_COUNT = PERFORMANCE_SPECIFICATION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.DNIUnit <em>Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.DNIUnit
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDNIUnit()
	 * @generated
	 */
	int DNI_UNIT = 51;

	/**
	 * The number of structural features of the '<em>Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DNI_UNIT_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DNI_UNIT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SpeedUnitImpl <em>Speed Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SpeedUnitImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSpeedUnit()
	 * @generated
	 */
	int SPEED_UNIT = 52;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT__UNIT = DNI_UNIT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT__PREFIX = DNI_UNIT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Speed Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT_FEATURE_COUNT = DNI_UNIT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Speed Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEED_UNIT_OPERATION_COUNT = DNI_UNIT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.DataUnitImpl <em>Data Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.DataUnitImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDataUnit()
	 * @generated
	 */
	int DATA_UNIT = 53;

	/**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_UNIT__PREFIX = DNI_UNIT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Data Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_UNIT_FEATURE_COUNT = DNI_UNIT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Data Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_UNIT_OPERATION_COUNT = DNI_UNIT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.TimeUnitImpl <em>Time Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.TimeUnitImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTimeUnit()
	 * @generated
	 */
	int TIME_UNIT = 54;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_UNIT__UNIT = DNI_UNIT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Time Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_UNIT_FEATURE_COUNT = DNI_UNIT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Time Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_UNIT_OPERATION_COUNT = DNI_UNIT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Dependency <em>Dependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Dependency
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDependency()
	 * @generated
	 */
	int DEPENDENCY = 55;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__UNIT = 0;

	/**
	 * The number of structural features of the '<em>Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Variable <em>Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Variable
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getVariable()
	 * @generated
	 */
	int VARIABLE = 56;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE__UNIT = DEPENDENCY__UNIT;

	/**
	 * The number of structural features of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_OPERATION_COUNT = DEPENDENCY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Function <em>Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Function
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFunction()
	 * @generated
	 */
	int FUNCTION = 57;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__UNIT = DEPENDENCY__UNIT;

	/**
	 * The number of structural features of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_OPERATION_COUNT = DEPENDENCY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.ConstantDoubleVariableImpl <em>Constant Double Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.ConstantDoubleVariableImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getConstantDoubleVariable()
	 * @generated
	 */
	int CONSTANT_DOUBLE_VARIABLE = 58;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE__UNIT = VARIABLE__UNIT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE__VALUE = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Double Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Constant Double Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.ConstantLongVariableImpl <em>Constant Long Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.ConstantLongVariableImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getConstantLongVariable()
	 * @generated
	 */
	int CONSTANT_LONG_VARIABLE = 59;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE__UNIT = VARIABLE__UNIT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE__VALUE = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Long Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Constant Long Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LONG_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.RandomVariableImpl <em>Random Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.RandomVariableImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getRandomVariable()
	 * @generated
	 */
	int RANDOM_VARIABLE = 60;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE__UNIT = VARIABLE__UNIT;

	/**
	 * The feature id for the '<em><b>Cdf</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE__CDF = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Random Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Random Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE_OPERATION_COUNT = VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.FloatCoordinateImpl <em>Float Coordinate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.FloatCoordinateImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFloatCoordinate()
	 * @generated
	 */
	int FLOAT_COORDINATE = 61;

	/**
	 * The feature id for the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOAT_COORDINATE__X = 0;

	/**
	 * The feature id for the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOAT_COORDINATE__Y = 1;

	/**
	 * The number of structural features of the '<em>Float Coordinate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOAT_COORDINATE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Float Coordinate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FLOAT_COORDINATE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.DiscreteFunctionImpl <em>Discrete Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.DiscreteFunctionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDiscreteFunction()
	 * @generated
	 */
	int DISCRETE_FUNCTION = 62;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION__UNIT = FUNCTION__UNIT;

	/**
	 * The feature id for the '<em><b>Vals</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION__VALS = FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Discrete Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION_FEATURE_COUNT = FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Discrete Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_FUNCTION_OPERATION_COUNT = FUNCTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.ExponentialFunctionImpl <em>Exponential Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.ExponentialFunctionImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getExponentialFunction()
	 * @generated
	 */
	int EXPONENTIAL_FUNCTION = 63;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION__UNIT = FUNCTION__UNIT;

	/**
	 * The feature id for the '<em><b>Lambda</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION__LAMBDA = FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Exponential Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION_FEATURE_COUNT = FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Exponential Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_FUNCTION_OPERATION_COUNT = FUNCTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.EntityTypesImpl <em>Entity Types</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.EntityTypesImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEntityTypes()
	 * @generated
	 */
	int ENTITY_TYPES = 64;

	/**
	 * The feature id for the '<em><b>Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_TYPES__TYPES = 0;

	/**
	 * The number of structural features of the '<em>Entity Types</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_TYPES_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Entity Types</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_TYPES_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.ITypedEntity <em>ITyped Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.ITypedEntity
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getITypedEntity()
	 * @generated
	 */
	int ITYPED_ENTITY = 65;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPED_ENTITY__NAME = NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPED_ENTITY__DESCRIPTION = NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPED_ENTITY__UID = NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPED_ENTITY__UID_GENERATED = NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>ITyped Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPED_ENTITY_FEATURE_COUNT = NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>ITyped Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITYPED_ENTITY_OPERATION_COUNT = NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NodeTypeImpl <em>Node Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NodeTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNodeType()
	 * @generated
	 */
	int NODE_TYPE = 66;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Node Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Node Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.EndPerformanceTypeImpl <em>End Performance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.EndPerformanceTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEndPerformanceType()
	 * @generated
	 */
	int END_PERFORMANCE_TYPE = 67;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>End Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>End Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int END_PERFORMANCE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.IntermediatePerformanceTypeImpl <em>Intermediate Performance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.IntermediatePerformanceTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIntermediatePerformanceType()
	 * @generated
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE = 68;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Intermediate Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Intermediate Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERMEDIATE_PERFORMANCE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.SdnNodePerformanceTypeImpl <em>Sdn Node Performance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.SdnNodePerformanceTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnNodePerformanceType()
	 * @generated
	 */
	int SDN_NODE_PERFORMANCE_TYPE = 69;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sdn Node Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Sdn Node Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDN_NODE_PERFORMANCE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceTypeImpl <em>Network Interface Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkInterfaceTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInterfaceType()
	 * @generated
	 */
	int NETWORK_INTERFACE_TYPE = 70;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Network Interface Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Network Interface Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInterfacePerformanceTypeImpl <em>Network Interface Performance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.NetworkInterfacePerformanceTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInterfacePerformanceType()
	 * @generated
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE = 71;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Network Interface Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Network Interface Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_INTERFACE_PERFORMANCE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.LinkTypeImpl <em>Link Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.LinkTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLinkType()
	 * @generated
	 */
	int LINK_TYPE = 72;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Link Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Link Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.impl.LinkPerformanceTypeImpl <em>Link Performance Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.impl.LinkPerformanceTypeImpl
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLinkPerformanceType()
	 * @generated
	 */
	int LINK_PERFORMANCE_TYPE = 73;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE__NAME = ITYPED_ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE__DESCRIPTION = ITYPED_ENTITY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE__UID = ITYPED_ENTITY__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE__UID_GENERATED = ITYPED_ENTITY__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Entities</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE__ENTITIES = ITYPED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Link Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE_FEATURE_COUNT = ITYPED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Link Performance Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_PERFORMANCE_TYPE_OPERATION_COUNT = ITYPED_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.UnitPrefix <em>Unit Prefix</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.UnitPrefix
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getUnitPrefix()
	 * @generated
	 */
	int UNIT_PREFIX = 74;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Speed <em>Speed</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Speed
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSpeed()
	 * @generated
	 */
	int SPEED = 75;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3.Time <em>Time</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3.Time
	 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTime()
	 * @generated
	 */
	int TIME = 76;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Named Element</em>'.
	 * @see tools.descartes.dni.dnimm3.NamedElement
	 * @generated
	 */
	EClass getNamedElement();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NamedElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3.NamedElement#getName()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_Name();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NamedElement#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see tools.descartes.dni.dnimm3.NamedElement#getDescription()
	 * @see #getNamedElement()
	 * @generated
	 */
	EAttribute getNamedElement_Description();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Identifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identifier</em>'.
	 * @see tools.descartes.dni.dnimm3.Identifier
	 * @generated
	 */
	EClass getIdentifier();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Identifier#getUid <em>Uid</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Uid</em>'.
	 * @see tools.descartes.dni.dnimm3.Identifier#getUid()
	 * @see #getIdentifier()
	 * @generated
	 */
	EAttribute getIdentifier_Uid();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Identifier#getUid_generated <em>Uid generated</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Uid generated</em>'.
	 * @see tools.descartes.dni.dnimm3.Identifier#getUid_generated()
	 * @see #getIdentifier()
	 * @generated
	 */
	EAttribute getIdentifier_Uid_generated();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity</em>'.
	 * @see tools.descartes.dni.dnimm3.Entity
	 * @generated
	 */
	EClass getEntity();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure <em>Network Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Infrastructure</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure
	 * @generated
	 */
	EClass getNetworkInfrastructure();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure#getTraffic <em>Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Traffic</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure#getTraffic()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Traffic();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure#getStructure <em>Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Structure</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure#getStructure()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Structure();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure#getConfiguration <em>Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Configuration</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure#getConfiguration()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_Configuration();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure#getEntityTypes <em>Entity Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Entity Types</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure#getEntityTypes()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EReference getNetworkInfrastructure_EntityTypes();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure#getDataCenterName <em>Data Center Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Center Name</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure#getDataCenterName()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EAttribute getNetworkInfrastructure_DataCenterName();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NetworkInfrastructure#getMetaModelVersion <em>Meta Model Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Meta Model Version</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInfrastructure#getMetaModelVersion()
	 * @see #getNetworkInfrastructure()
	 * @generated
	 */
	EAttribute getNetworkInfrastructure_MetaModelVersion();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkStructure <em>Network Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Structure</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkStructure
	 * @generated
	 */
	EClass getNetworkStructure();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.NetworkStructure#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkStructure#getNodes()
	 * @see #getNetworkStructure()
	 * @generated
	 */
	EReference getNetworkStructure_Nodes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.NetworkStructure#getLinks <em>Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Links</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkStructure#getLinks()
	 * @see #getNetworkStructure()
	 * @generated
	 */
	EReference getNetworkStructure_Links();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Node <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Node</em>'.
	 * @see tools.descartes.dni.dnimm3.Node
	 * @generated
	 */
	EClass getNode();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.Node#getInterfaces <em>Interfaces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interfaces</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getInterfaces()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Interfaces();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Node#getSdntype <em>Sdntype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sdntype</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getSdntype()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Sdntype();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Node#isIsPhysical <em>Is Physical</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Physical</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#isIsPhysical()
	 * @see #getNode()
	 * @generated
	 */
	EAttribute getNode_IsPhysical();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Node#isIsPhysical_derived <em>Is Physical derived</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Physical derived</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#isIsPhysical_derived()
	 * @see #getNode()
	 * @generated
	 */
	EAttribute getNode_IsPhysical_derived();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.Node#getHosts <em>Hosts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Hosts</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getHosts()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Hosts();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Node#getIsHostedOn <em>Is Hosted On</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Is Hosted On</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getIsHostedOn()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_IsHostedOn();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Node#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>End</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getEnd()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_End();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Node#getIntermediate <em>Intermediate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Intermediate</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getIntermediate()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_Intermediate();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Node#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.Node#getEntityType()
	 * @see #getNode()
	 * @generated
	 */
	EReference getNode_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.End <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End</em>'.
	 * @see tools.descartes.dni.dnimm3.End
	 * @generated
	 */
	EClass getEnd();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.End#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.End#getPerformance()
	 * @see #getEnd()
	 * @generated
	 */
	EReference getEnd_Performance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.End#getSoftware <em>Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Software</em>'.
	 * @see tools.descartes.dni.dnimm3.End#getSoftware()
	 * @see #getEnd()
	 * @generated
	 */
	EReference getEnd_Software();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dni.dnimm3.End#getNode <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Node</em>'.
	 * @see tools.descartes.dni.dnimm3.End#getNode()
	 * @see #getEnd()
	 * @generated
	 */
	EReference getEnd_Node();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.End#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3.End#getName()
	 * @see #getEnd()
	 * @generated
	 */
	EAttribute getEnd_Name();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Intermediate <em>Intermediate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Intermediate</em>'.
	 * @see tools.descartes.dni.dnimm3.Intermediate
	 * @generated
	 */
	EClass getIntermediate();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Intermediate#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.Intermediate#getPerformance()
	 * @see #getIntermediate()
	 * @generated
	 */
	EReference getIntermediate_Performance();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dni.dnimm3.Intermediate#getNode <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Node</em>'.
	 * @see tools.descartes.dni.dnimm3.Intermediate#getNode()
	 * @see #getIntermediate()
	 * @generated
	 */
	EReference getIntermediate_Node();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Intermediate#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3.Intermediate#getName()
	 * @see #getIntermediate()
	 * @generated
	 */
	EAttribute getIntermediate_Name();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Link <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link</em>'.
	 * @see tools.descartes.dni.dnimm3.Link
	 * @generated
	 */
	EClass getLink();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.Link#getConnects <em>Connects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Connects</em>'.
	 * @see tools.descartes.dni.dnimm3.Link#getConnects()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_Connects();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Link#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.Link#getPerformance()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_Performance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Link#getName_generated <em>Name generated</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name generated</em>'.
	 * @see tools.descartes.dni.dnimm3.Link#getName_generated()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_Name_generated();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Link#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.Link#getEntityType()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterface
	 * @generated
	 */
	EClass getNetworkInterface();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.NetworkInterface#getUsedProtocolStack <em>Used Protocol Stack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Used Protocol Stack</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterface#getUsedProtocolStack()
	 * @see #getNetworkInterface()
	 * @generated
	 */
	EReference getNetworkInterface_UsedProtocolStack();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkInterface#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterface#getPerformance()
	 * @see #getNetworkInterface()
	 * @generated
	 */
	EReference getNetworkInterface_Performance();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dni.dnimm3.NetworkInterface#getNode <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Node</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterface#getNode()
	 * @see #getNetworkInterface()
	 * @generated
	 */
	EReference getNetworkInterface_Node();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NetworkInterface#getName_generated <em>Name generated</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name generated</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterface#getName_generated()
	 * @see #getNetworkInterface()
	 * @generated
	 */
	EAttribute getNetworkInterface_Name_generated();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.NetworkInterface#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterface#getEntityType()
	 * @see #getNetworkInterface()
	 * @generated
	 */
	EReference getNetworkInterface_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkTraffic <em>Network Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Traffic</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkTraffic
	 * @generated
	 */
	EClass getNetworkTraffic();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.NetworkTraffic#getFlows <em>Flows</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Flows</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkTraffic#getFlows()
	 * @see #getNetworkTraffic()
	 * @generated
	 */
	EReference getNetworkTraffic_Flows();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.NetworkTraffic#getSoftware <em>Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Software</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkTraffic#getSoftware()
	 * @see #getNetworkTraffic()
	 * @generated
	 */
	EReference getNetworkTraffic_Software();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Flow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.Flow
	 * @generated
	 */
	EClass getFlow();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Flow#getSourceSoftware <em>Source Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Software</em>'.
	 * @see tools.descartes.dni.dnimm3.Flow#getSourceSoftware()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_SourceSoftware();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.Flow#getGeneratedTraffic <em>Generated Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Generated Traffic</em>'.
	 * @see tools.descartes.dni.dnimm3.Flow#getGeneratedTraffic()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_GeneratedTraffic();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.Flow#getDestinationSoftware <em>Destination Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Destination Software</em>'.
	 * @see tools.descartes.dni.dnimm3.Flow#getDestinationSoftware()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_DestinationSoftware();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.Flow#getDestinationAddresses <em>Destination Addresses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Destination Addresses</em>'.
	 * @see tools.descartes.dni.dnimm3.Flow#getDestinationAddresses()
	 * @see #getFlow()
	 * @generated
	 */
	EReference getFlow_DestinationAddresses();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SdnControlFlow <em>Sdn Control Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdn Control Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnControlFlow
	 * @generated
	 */
	EClass getSdnControlFlow();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.SdnControlFlow#getParentFlow <em>Parent Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parent Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnControlFlow#getParentFlow()
	 * @see #getSdnControlFlow()
	 * @generated
	 */
	EReference getSdnControlFlow_ParentFlow();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.FlowTraffic <em>Flow Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Traffic</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowTraffic
	 * @generated
	 */
	EClass getFlowTraffic();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dni.dnimm3.FlowTraffic#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowTraffic#getFlow()
	 * @see #getFlowTraffic()
	 * @generated
	 */
	EReference getFlowTraffic_Flow();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.FlowTraffic#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowTraffic#getName()
	 * @see #getFlowTraffic()
	 * @generated
	 */
	EAttribute getFlowTraffic_Name();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.GenericFlowTraffic <em>Generic Flow Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Flow Traffic</em>'.
	 * @see tools.descartes.dni.dnimm3.GenericFlowTraffic
	 * @generated
	 */
	EClass getGenericFlowTraffic();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.GenericFlowTraffic#getDataSize <em>Data Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Size</em>'.
	 * @see tools.descartes.dni.dnimm3.GenericFlowTraffic#getDataSize()
	 * @see #getGenericFlowTraffic()
	 * @generated
	 */
	EReference getGenericFlowTraffic_DataSize();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.CommunicatingApplication <em>Communicating Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Communicating Application</em>'.
	 * @see tools.descartes.dni.dnimm3.CommunicatingApplication
	 * @generated
	 */
	EClass getCommunicatingApplication();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.CommunicatingApplication#getTrafficSources <em>Traffic Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Traffic Sources</em>'.
	 * @see tools.descartes.dni.dnimm3.CommunicatingApplication#getTrafficSources()
	 * @see #getCommunicatingApplication()
	 * @generated
	 */
	EReference getCommunicatingApplication_TrafficSources();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.CommunicatingApplication#getDeployedOn <em>Deployed On</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Deployed On</em>'.
	 * @see tools.descartes.dni.dnimm3.CommunicatingApplication#getDeployedOn()
	 * @see #getCommunicatingApplication()
	 * @generated
	 */
	EReference getCommunicatingApplication_DeployedOn();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.TrafficSource <em>Traffic Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Traffic Source</em>'.
	 * @see tools.descartes.dni.dnimm3.TrafficSource
	 * @generated
	 */
	EClass getTrafficSource();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.TrafficSource#getWorkload <em>Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Workload</em>'.
	 * @see tools.descartes.dni.dnimm3.TrafficSource#getWorkload()
	 * @see #getTrafficSource()
	 * @generated
	 */
	EReference getTrafficSource_Workload();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dni.dnimm3.TrafficSource#getSoftwareComponent <em>Software Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Software Component</em>'.
	 * @see tools.descartes.dni.dnimm3.TrafficSource#getSoftwareComponent()
	 * @see #getTrafficSource()
	 * @generated
	 */
	EReference getTrafficSource_SoftwareComponent();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkConfiguration <em>Network Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Configuration</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkConfiguration
	 * @generated
	 */
	EClass getNetworkConfiguration();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkConfiguration#getProtocolsAndStacks <em>Protocols And Stacks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Protocols And Stacks</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkConfiguration#getProtocolsAndStacks()
	 * @see #getNetworkConfiguration()
	 * @generated
	 */
	EReference getNetworkConfiguration_ProtocolsAndStacks();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.NetworkConfiguration#getRoutes <em>Routes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Routes</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkConfiguration#getRoutes()
	 * @see #getNetworkConfiguration()
	 * @generated
	 */
	EReference getNetworkConfiguration_Routes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.NetworkConfiguration#getRules <em>Rules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rules</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkConfiguration#getRules()
	 * @see #getNetworkConfiguration()
	 * @generated
	 */
	EReference getNetworkConfiguration_Rules();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ProtocolsRepository <em>Protocols Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocols Repository</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolsRepository
	 * @generated
	 */
	EClass getProtocolsRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.ProtocolsRepository#getStacks <em>Stacks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Stacks</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolsRepository#getStacks()
	 * @see #getProtocolsRepository()
	 * @generated
	 */
	EReference getProtocolsRepository_Stacks();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.ProtocolsRepository#getProtocols <em>Protocols</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Protocols</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolsRepository#getProtocols()
	 * @see #getProtocolsRepository()
	 * @generated
	 */
	EReference getProtocolsRepository_Protocols();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ProtocolStack <em>Protocol Stack</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocol Stack</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolStack
	 * @generated
	 */
	EClass getProtocolStack();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.ProtocolStack#getLayers <em>Layers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Layers</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolStack#getLayers()
	 * @see #getProtocolStack()
	 * @generated
	 */
	EReference getProtocolStack_Layers();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ProtocolLayer <em>Protocol Layer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Protocol Layer</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolLayer
	 * @generated
	 */
	EClass getProtocolLayer();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.ProtocolLayer#getProtocol <em>Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Protocol</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolLayer#getProtocol()
	 * @see #getProtocolLayer()
	 * @generated
	 */
	EReference getProtocolLayer_Protocol();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.ProtocolLayer#getIsCarriedBy <em>Is Carried By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Is Carried By</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolLayer#getIsCarriedBy()
	 * @see #getProtocolLayer()
	 * @generated
	 */
	EReference getProtocolLayer_IsCarriedBy();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.ProtocolLayer#getCarries <em>Carries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Carries</em>'.
	 * @see tools.descartes.dni.dnimm3.ProtocolLayer#getCarries()
	 * @see #getProtocolLayer()
	 * @generated
	 */
	EReference getProtocolLayer_Carries();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkProtocol <em>Network Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Protocol</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkProtocol
	 * @generated
	 */
	EClass getNetworkProtocol();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NetworkProtocol#getMtu <em>Mtu</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mtu</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkProtocol#getMtu()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_Mtu();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.NetworkProtocol#getHeadersLength <em>Headers Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Headers Length</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkProtocol#getHeadersLength()
	 * @see #getNetworkProtocol()
	 * @generated
	 */
	EAttribute getNetworkProtocol_HeadersLength();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.RoutesRepository <em>Routes Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Routes Repository</em>'.
	 * @see tools.descartes.dni.dnimm3.RoutesRepository
	 * @generated
	 */
	EClass getRoutesRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.RoutesRepository#getRoutes <em>Routes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Routes</em>'.
	 * @see tools.descartes.dni.dnimm3.RoutesRepository#getRoutes()
	 * @see #getRoutesRepository()
	 * @generated
	 */
	EReference getRoutesRepository_Routes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.RoutesRepository#getFlowRoutes <em>Flow Routes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Flow Routes</em>'.
	 * @see tools.descartes.dni.dnimm3.RoutesRepository#getFlowRoutes()
	 * @see #getRoutesRepository()
	 * @generated
	 */
	EReference getRoutesRepository_FlowRoutes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.RoutesRepository#getDirections <em>Directions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Directions</em>'.
	 * @see tools.descartes.dni.dnimm3.RoutesRepository#getDirections()
	 * @see #getRoutesRepository()
	 * @generated
	 */
	EReference getRoutesRepository_Directions();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Direction <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Direction</em>'.
	 * @see tools.descartes.dni.dnimm3.Direction
	 * @generated
	 */
	EClass getDirection();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Direction#getOnNode <em>On Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>On Node</em>'.
	 * @see tools.descartes.dni.dnimm3.Direction#getOnNode()
	 * @see #getDirection()
	 * @generated
	 */
	EReference getDirection_OnNode();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Direction#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.Direction#getFlow()
	 * @see #getDirection()
	 * @generated
	 */
	EReference getDirection_Flow();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Direction#getVia <em>Via</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Via</em>'.
	 * @see tools.descartes.dni.dnimm3.Direction#getVia()
	 * @see #getDirection()
	 * @generated
	 */
	EReference getDirection_Via();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Direction#getDefault <em>Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default</em>'.
	 * @see tools.descartes.dni.dnimm3.Direction#getDefault()
	 * @see #getDirection()
	 * @generated
	 */
	EAttribute getDirection_Default();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.Direction#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see tools.descartes.dni.dnimm3.Direction#getProbability()
	 * @see #getDirection()
	 * @generated
	 */
	EAttribute getDirection_Probability();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.FlowRoute <em>Flow Route</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Flow Route</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowRoute
	 * @generated
	 */
	EClass getFlowRoute();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.FlowRoute#getHops <em>Hops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hops</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowRoute#getHops()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_Hops();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.FlowRoute#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowRoute#getFlow()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_Flow();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.FlowRoute#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowRoute#getStart()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_Start();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.FlowRoute#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>End</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowRoute#getEnd()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EReference getFlowRoute_End();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.FlowRoute#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see tools.descartes.dni.dnimm3.FlowRoute#getProbability()
	 * @see #getFlowRoute()
	 * @generated
	 */
	EAttribute getFlowRoute_Probability();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Route <em>Route</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Route</em>'.
	 * @see tools.descartes.dni.dnimm3.Route
	 * @generated
	 */
	EClass getRoute();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Route#getHops <em>Hops</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hops</em>'.
	 * @see tools.descartes.dni.dnimm3.Route#getHops()
	 * @see #getRoute()
	 * @generated
	 */
	EReference getRoute_Hops();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Route#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start</em>'.
	 * @see tools.descartes.dni.dnimm3.Route#getStart()
	 * @see #getRoute()
	 * @generated
	 */
	EReference getRoute_Start();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Route#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>End</em>'.
	 * @see tools.descartes.dni.dnimm3.Route#getEnd()
	 * @see #getRoute()
	 * @generated
	 */
	EReference getRoute_End();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Hop <em>Hop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hop</em>'.
	 * @see tools.descartes.dni.dnimm3.Hop
	 * @generated
	 */
	EClass getHop();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Hop#getNextHop <em>Next Hop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Next Hop</em>'.
	 * @see tools.descartes.dni.dnimm3.Hop#getNextHop()
	 * @see #getHop()
	 * @generated
	 */
	EReference getHop_NextHop();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.Hop#getInterfaceref <em>Interfaceref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interfaceref</em>'.
	 * @see tools.descartes.dni.dnimm3.Hop#getInterfaceref()
	 * @see #getHop()
	 * @generated
	 */
	EReference getHop_Interfaceref();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.EntityAddress <em>Entity Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity Address</em>'.
	 * @see tools.descartes.dni.dnimm3.EntityAddress
	 * @generated
	 */
	EClass getEntityAddress();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.EntityAddress#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Address</em>'.
	 * @see tools.descartes.dni.dnimm3.EntityAddress#getAddress()
	 * @see #getEntityAddress()
	 * @generated
	 */
	EAttribute getEntityAddress_Address();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.EntityAddress#getAddressGivenBy <em>Address Given By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Address Given By</em>'.
	 * @see tools.descartes.dni.dnimm3.EntityAddress#getAddressGivenBy()
	 * @see #getEntityAddress()
	 * @generated
	 */
	EReference getEntityAddress_AddressGivenBy();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.AddressableEntity <em>Addressable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Addressable Entity</em>'.
	 * @see tools.descartes.dni.dnimm3.AddressableEntity
	 * @generated
	 */
	EClass getAddressableEntity();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.AddressableEntity#getAddresses <em>Addresses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Addresses</em>'.
	 * @see tools.descartes.dni.dnimm3.AddressableEntity#getAddresses()
	 * @see #getAddressableEntity()
	 * @generated
	 */
	EReference getAddressableEntity_Addresses();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Workload <em>Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Workload</em>'.
	 * @see tools.descartes.dni.dnimm3.Workload
	 * @generated
	 */
	EClass getWorkload();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.GenericWorkload <em>Generic Workload</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Workload</em>'.
	 * @see tools.descartes.dni.dnimm3.GenericWorkload
	 * @generated
	 */
	EClass getGenericWorkload();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.GenericWorkload#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actions</em>'.
	 * @see tools.descartes.dni.dnimm3.GenericWorkload#getActions()
	 * @see #getGenericWorkload()
	 * @generated
	 */
	EReference getGenericWorkload_Actions();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.AbstractAction <em>Abstract Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Action</em>'.
	 * @see tools.descartes.dni.dnimm3.AbstractAction
	 * @generated
	 */
	EClass getAbstractAction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.BranchAction <em>Branch Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Branch Action</em>'.
	 * @see tools.descartes.dni.dnimm3.BranchAction
	 * @generated
	 */
	EClass getBranchAction();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.BranchAction#getIntern <em>Intern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Intern</em>'.
	 * @see tools.descartes.dni.dnimm3.BranchAction#getIntern()
	 * @see #getBranchAction()
	 * @generated
	 */
	EReference getBranchAction_Intern();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.LoopAction <em>Loop Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Action</em>'.
	 * @see tools.descartes.dni.dnimm3.LoopAction
	 * @generated
	 */
	EClass getLoopAction();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.LoopAction#getIntern <em>Intern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Intern</em>'.
	 * @see tools.descartes.dni.dnimm3.LoopAction#getIntern()
	 * @see #getLoopAction()
	 * @generated
	 */
	EReference getLoopAction_Intern();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.LoopAction#getNumIterations <em>Num Iterations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Num Iterations</em>'.
	 * @see tools.descartes.dni.dnimm3.LoopAction#getNumIterations()
	 * @see #getLoopAction()
	 * @generated
	 */
	EReference getLoopAction_NumIterations();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SequenceAction <em>Sequence Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sequence Action</em>'.
	 * @see tools.descartes.dni.dnimm3.SequenceAction
	 * @generated
	 */
	EClass getSequenceAction();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.SequenceAction#getIntern <em>Intern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Intern</em>'.
	 * @see tools.descartes.dni.dnimm3.SequenceAction#getIntern()
	 * @see #getSequenceAction()
	 * @generated
	 */
	EReference getSequenceAction_Intern();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.StartAction <em>Start Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Start Action</em>'.
	 * @see tools.descartes.dni.dnimm3.StartAction
	 * @generated
	 */
	EClass getStartAction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.StopAction <em>Stop Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stop Action</em>'.
	 * @see tools.descartes.dni.dnimm3.StopAction
	 * @generated
	 */
	EClass getStopAction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.TransmitAction <em>Transmit Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Transmit Action</em>'.
	 * @see tools.descartes.dni.dnimm3.TransmitAction
	 * @generated
	 */
	EClass getTransmitAction();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.TransmitAction#getFlowTraffic <em>Flow Traffic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow Traffic</em>'.
	 * @see tools.descartes.dni.dnimm3.TransmitAction#getFlowTraffic()
	 * @see #getTransmitAction()
	 * @generated
	 */
	EReference getTransmitAction_FlowTraffic();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.WaitAction <em>Wait Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Wait Action</em>'.
	 * @see tools.descartes.dni.dnimm3.WaitAction
	 * @generated
	 */
	EClass getWaitAction();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.WaitAction#getWaitTime <em>Wait Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Wait Time</em>'.
	 * @see tools.descartes.dni.dnimm3.WaitAction#getWaitTime()
	 * @see #getWaitAction()
	 * @generated
	 */
	EReference getWaitAction_WaitTime();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.PerformanceSpecification <em>Performance Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Performance Specification</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceSpecification
	 * @generated
	 */
	EClass getPerformanceSpecification();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.PerformanceLink <em>Performance Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Performance Link</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceLink
	 * @generated
	 */
	EClass getPerformanceLink();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.PerformanceLink#getPropagationDelay <em>Propagation Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Propagation Delay</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceLink#getPropagationDelay()
	 * @see #getPerformanceLink()
	 * @generated
	 */
	EReference getPerformanceLink_PropagationDelay();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.PerformanceLink#getMaxSupportedBandwidth <em>Max Supported Bandwidth</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Max Supported Bandwidth</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceLink#getMaxSupportedBandwidth()
	 * @see #getPerformanceLink()
	 * @generated
	 */
	EReference getPerformanceLink_MaxSupportedBandwidth();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.PerformanceLink#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceLink#getEntityType()
	 * @see #getPerformanceLink()
	 * @generated
	 */
	EReference getPerformanceLink_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface <em>Performance Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Performance Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceNetworkInterface
	 * @generated
	 */
	EClass getPerformanceNetworkInterface();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface#isIsUp <em>Is Up</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Up</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceNetworkInterface#isIsUp()
	 * @see #getPerformanceNetworkInterface()
	 * @generated
	 */
	EAttribute getPerformanceNetworkInterface_IsUp();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getMTU <em>MTU</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>MTU</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getMTU()
	 * @see #getPerformanceNetworkInterface()
	 * @generated
	 */
	EAttribute getPerformanceNetworkInterface_MTU();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getPacketProcessingTime <em>Packet Processing Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Processing Time</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getPacketProcessingTime()
	 * @see #getPerformanceNetworkInterface()
	 * @generated
	 */
	EReference getPerformanceNetworkInterface_PacketProcessingTime();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getInterfaceThroughput <em>Interface Throughput</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Throughput</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getInterfaceThroughput()
	 * @see #getPerformanceNetworkInterface()
	 * @generated
	 */
	EReference getPerformanceNetworkInterface_InterfaceThroughput();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceNetworkInterface#getEntityType()
	 * @see #getPerformanceNetworkInterface()
	 * @generated
	 */
	EReference getPerformanceNetworkInterface_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SdnFlowRule <em>Sdn Flow Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdn Flow Rule</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule
	 * @generated
	 */
	EClass getSdnFlowRule();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.SdnFlowRule#getSdnSwitch <em>Sdn Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Sdn Switch</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule#getSdnSwitch()
	 * @see #getSdnFlowRule()
	 * @generated
	 */
	EReference getSdnFlowRule_SdnSwitch();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.SdnFlowRule#getFlow <em>Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Flow</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule#getFlow()
	 * @see #getSdnFlowRule()
	 * @generated
	 */
	EReference getSdnFlowRule_Flow();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.SdnFlowRule#getProbabilityHardware <em>Probability Hardware</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability Hardware</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule#getProbabilityHardware()
	 * @see #getSdnFlowRule()
	 * @generated
	 */
	EAttribute getSdnFlowRule_ProbabilityHardware();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.SdnFlowRule#getProbabilitySoftware <em>Probability Software</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability Software</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule#getProbabilitySoftware()
	 * @see #getSdnFlowRule()
	 * @generated
	 */
	EAttribute getSdnFlowRule_ProbabilitySoftware();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.SdnFlowRule#getProbabilityController <em>Probability Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability Controller</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule#getProbabilityController()
	 * @see #getSdnFlowRule()
	 * @generated
	 */
	EAttribute getSdnFlowRule_ProbabilityController();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.SdnFlowRule#getControllerApplication <em>Controller Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Controller Application</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnFlowRule#getControllerApplication()
	 * @see #getSdnFlowRule()
	 * @generated
	 */
	EReference getSdnFlowRule_ControllerApplication();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SdnController <em>Sdn Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdn Controller</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnController
	 * @generated
	 */
	EClass getSdnController();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.SdnController#getApplications <em>Applications</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Applications</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnController#getApplications()
	 * @see #getSdnController()
	 * @generated
	 */
	EReference getSdnController_Applications();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.SdnController#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Nodes</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnController#getNodes()
	 * @see #getSdnController()
	 * @generated
	 */
	EReference getSdnController_Nodes();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SdnControllerApplication <em>Sdn Controller Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdn Controller Application</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnControllerApplication
	 * @generated
	 */
	EClass getSdnControllerApplication();

	/**
	 * Returns the meta object for the container reference '{@link tools.descartes.dni.dnimm3.SdnControllerApplication#getBelongsTo <em>Belongs To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Belongs To</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnControllerApplication#getBelongsTo()
	 * @see #getSdnControllerApplication()
	 * @generated
	 */
	EReference getSdnControllerApplication_BelongsTo();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.SdnControllerApplication#isIsDefault <em>Is Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Default</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnControllerApplication#isIsDefault()
	 * @see #getSdnControllerApplication()
	 * @generated
	 */
	EAttribute getSdnControllerApplication_IsDefault();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.SdnControllerApplication#getResponseDelay <em>Response Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Response Delay</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnControllerApplication#getResponseDelay()
	 * @see #getSdnControllerApplication()
	 * @generated
	 */
	EReference getSdnControllerApplication_ResponseDelay();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.IType <em>IType</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IType</em>'.
	 * @see tools.descartes.dni.dnimm3.IType
	 * @generated
	 */
	EClass getIType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Common <em>Common</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Common</em>'.
	 * @see tools.descartes.dni.dnimm3.Common
	 * @generated
	 */
	EClass getCommon();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SDN <em>SDN</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SDN</em>'.
	 * @see tools.descartes.dni.dnimm3.SDN
	 * @generated
	 */
	EClass getSDN();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.SDN#getPerformance <em>Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.SDN#getPerformance()
	 * @see #getSDN()
	 * @generated
	 */
	EReference getSDN_Performance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.SDN#getController <em>Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Controller</em>'.
	 * @see tools.descartes.dni.dnimm3.SDN#getController()
	 * @see #getSDN()
	 * @generated
	 */
	EReference getSDN_Controller();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.SDN#getOpenFlowEndPoint <em>Open Flow End Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Open Flow End Point</em>'.
	 * @see tools.descartes.dni.dnimm3.SDN#getOpenFlowEndPoint()
	 * @see #getSDN()
	 * @generated
	 */
	EReference getSDN_OpenFlowEndPoint();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.IntermediatePerformance <em>Intermediate Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Intermediate Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformance
	 * @generated
	 */
	EClass getIntermediatePerformance();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.IntermediatePerformance#getForwardingLatency <em>Forwarding Latency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Latency</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformance#getForwardingLatency()
	 * @see #getIntermediatePerformance()
	 * @generated
	 */
	EReference getIntermediatePerformance_ForwardingLatency();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.IntermediatePerformance#getForwardingBandwidthBPS <em>Forwarding Bandwidth BPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Bandwidth BPS</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformance#getForwardingBandwidthBPS()
	 * @see #getIntermediatePerformance()
	 * @generated
	 */
	EReference getIntermediatePerformance_ForwardingBandwidthBPS();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.IntermediatePerformance#getSwitchingCapacityPPS <em>Switching Capacity PPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Switching Capacity PPS</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformance#getSwitchingCapacityPPS()
	 * @see #getIntermediatePerformance()
	 * @generated
	 */
	EReference getIntermediatePerformance_SwitchingCapacityPPS();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.IntermediatePerformance#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformance#getEntityType()
	 * @see #getIntermediatePerformance()
	 * @generated
	 */
	EReference getIntermediatePerformance_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.EndPerformance <em>End Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.EndPerformance
	 * @generated
	 */
	EClass getEndPerformance();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.EndPerformance#getSoftwareLayersDelay <em>Software Layers Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Software Layers Delay</em>'.
	 * @see tools.descartes.dni.dnimm3.EndPerformance#getSoftwareLayersDelay()
	 * @see #getEndPerformance()
	 * @generated
	 */
	EReference getEndPerformance_SoftwareLayersDelay();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.EndPerformance#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.EndPerformance#getEntityType()
	 * @see #getEndPerformance()
	 * @generated
	 */
	EReference getEndPerformance_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.PerformanceSdnNode <em>Performance Sdn Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Performance Sdn Node</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceSdnNode
	 * @generated
	 */
	EClass getPerformanceSdnNode();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.PerformanceSdnNode#getSoftwareSwitchingPerformance <em>Software Switching Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Software Switching Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceSdnNode#getSoftwareSwitchingPerformance()
	 * @see #getPerformanceSdnNode()
	 * @generated
	 */
	EReference getPerformanceSdnNode_SoftwareSwitchingPerformance();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.PerformanceSdnNode#getHardwareSwitchingPerformance <em>Hardware Switching Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hardware Switching Performance</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceSdnNode#getHardwareSwitchingPerformance()
	 * @see #getPerformanceSdnNode()
	 * @generated
	 */
	EReference getPerformanceSdnNode_HardwareSwitchingPerformance();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3.PerformanceSdnNode#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3.PerformanceSdnNode#getEntityType()
	 * @see #getPerformanceSdnNode()
	 * @generated
	 */
	EReference getPerformanceSdnNode_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.DNIUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.DNIUnit
	 * @generated
	 */
	EClass getDNIUnit();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SpeedUnit <em>Speed Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Speed Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.SpeedUnit
	 * @generated
	 */
	EClass getSpeedUnit();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.SpeedUnit#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.SpeedUnit#getUnit()
	 * @see #getSpeedUnit()
	 * @generated
	 */
	EAttribute getSpeedUnit_Unit();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.SpeedUnit#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see tools.descartes.dni.dnimm3.SpeedUnit#getPrefix()
	 * @see #getSpeedUnit()
	 * @generated
	 */
	EAttribute getSpeedUnit_Prefix();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.DataUnit <em>Data Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.DataUnit
	 * @generated
	 */
	EClass getDataUnit();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.DataUnit#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see tools.descartes.dni.dnimm3.DataUnit#getPrefix()
	 * @see #getDataUnit()
	 * @generated
	 */
	EAttribute getDataUnit_Prefix();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.TimeUnit <em>Time Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Time Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.TimeUnit
	 * @generated
	 */
	EClass getTimeUnit();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.TimeUnit#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.TimeUnit#getUnit()
	 * @see #getTimeUnit()
	 * @generated
	 */
	EAttribute getTimeUnit_Unit();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Dependency <em>Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency</em>'.
	 * @see tools.descartes.dni.dnimm3.Dependency
	 * @generated
	 */
	EClass getDependency();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.Dependency#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unit</em>'.
	 * @see tools.descartes.dni.dnimm3.Dependency#getUnit()
	 * @see #getDependency()
	 * @generated
	 */
	EReference getDependency_Unit();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Variable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable</em>'.
	 * @see tools.descartes.dni.dnimm3.Variable
	 * @generated
	 */
	EClass getVariable();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function</em>'.
	 * @see tools.descartes.dni.dnimm3.Function
	 * @generated
	 */
	EClass getFunction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ConstantDoubleVariable <em>Constant Double Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Double Variable</em>'.
	 * @see tools.descartes.dni.dnimm3.ConstantDoubleVariable
	 * @generated
	 */
	EClass getConstantDoubleVariable();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.ConstantDoubleVariable#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see tools.descartes.dni.dnimm3.ConstantDoubleVariable#getValue()
	 * @see #getConstantDoubleVariable()
	 * @generated
	 */
	EAttribute getConstantDoubleVariable_Value();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ConstantLongVariable <em>Constant Long Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Long Variable</em>'.
	 * @see tools.descartes.dni.dnimm3.ConstantLongVariable
	 * @generated
	 */
	EClass getConstantLongVariable();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.ConstantLongVariable#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see tools.descartes.dni.dnimm3.ConstantLongVariable#getValue()
	 * @see #getConstantLongVariable()
	 * @generated
	 */
	EAttribute getConstantLongVariable_Value();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.RandomVariable <em>Random Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Random Variable</em>'.
	 * @see tools.descartes.dni.dnimm3.RandomVariable
	 * @generated
	 */
	EClass getRandomVariable();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3.RandomVariable#getCdf <em>Cdf</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Cdf</em>'.
	 * @see tools.descartes.dni.dnimm3.RandomVariable#getCdf()
	 * @see #getRandomVariable()
	 * @generated
	 */
	EReference getRandomVariable_Cdf();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.FloatCoordinate <em>Float Coordinate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Float Coordinate</em>'.
	 * @see tools.descartes.dni.dnimm3.FloatCoordinate
	 * @generated
	 */
	EClass getFloatCoordinate();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.FloatCoordinate#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>X</em>'.
	 * @see tools.descartes.dni.dnimm3.FloatCoordinate#getX()
	 * @see #getFloatCoordinate()
	 * @generated
	 */
	EAttribute getFloatCoordinate_X();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.FloatCoordinate#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Y</em>'.
	 * @see tools.descartes.dni.dnimm3.FloatCoordinate#getY()
	 * @see #getFloatCoordinate()
	 * @generated
	 */
	EAttribute getFloatCoordinate_Y();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.DiscreteFunction <em>Discrete Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Discrete Function</em>'.
	 * @see tools.descartes.dni.dnimm3.DiscreteFunction
	 * @generated
	 */
	EClass getDiscreteFunction();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.DiscreteFunction#getVals <em>Vals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Vals</em>'.
	 * @see tools.descartes.dni.dnimm3.DiscreteFunction#getVals()
	 * @see #getDiscreteFunction()
	 * @generated
	 */
	EReference getDiscreteFunction_Vals();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ExponentialFunction <em>Exponential Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exponential Function</em>'.
	 * @see tools.descartes.dni.dnimm3.ExponentialFunction
	 * @generated
	 */
	EClass getExponentialFunction();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3.ExponentialFunction#getLambda <em>Lambda</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lambda</em>'.
	 * @see tools.descartes.dni.dnimm3.ExponentialFunction#getLambda()
	 * @see #getExponentialFunction()
	 * @generated
	 */
	EAttribute getExponentialFunction_Lambda();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.EntityTypes <em>Entity Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity Types</em>'.
	 * @see tools.descartes.dni.dnimm3.EntityTypes
	 * @generated
	 */
	EClass getEntityTypes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3.EntityTypes#getTypes <em>Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Types</em>'.
	 * @see tools.descartes.dni.dnimm3.EntityTypes#getTypes()
	 * @see #getEntityTypes()
	 * @generated
	 */
	EReference getEntityTypes_Types();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.ITypedEntity <em>ITyped Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>ITyped Entity</em>'.
	 * @see tools.descartes.dni.dnimm3.ITypedEntity
	 * @generated
	 */
	EClass getITypedEntity();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NodeType <em>Node Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Node Type</em>'.
	 * @see tools.descartes.dni.dnimm3.NodeType
	 * @generated
	 */
	EClass getNodeType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.NodeType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.NodeType#getEntities()
	 * @see #getNodeType()
	 * @generated
	 */
	EReference getNodeType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.EndPerformanceType <em>End Performance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>End Performance Type</em>'.
	 * @see tools.descartes.dni.dnimm3.EndPerformanceType
	 * @generated
	 */
	EClass getEndPerformanceType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.EndPerformanceType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.EndPerformanceType#getEntities()
	 * @see #getEndPerformanceType()
	 * @generated
	 */
	EReference getEndPerformanceType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.IntermediatePerformanceType <em>Intermediate Performance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Intermediate Performance Type</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformanceType
	 * @generated
	 */
	EClass getIntermediatePerformanceType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.IntermediatePerformanceType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.IntermediatePerformanceType#getEntities()
	 * @see #getIntermediatePerformanceType()
	 * @generated
	 */
	EReference getIntermediatePerformanceType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.SdnNodePerformanceType <em>Sdn Node Performance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdn Node Performance Type</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnNodePerformanceType
	 * @generated
	 */
	EClass getSdnNodePerformanceType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.SdnNodePerformanceType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.SdnNodePerformanceType#getEntities()
	 * @see #getSdnNodePerformanceType()
	 * @generated
	 */
	EReference getSdnNodePerformanceType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkInterfaceType <em>Network Interface Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Interface Type</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterfaceType
	 * @generated
	 */
	EClass getNetworkInterfaceType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.NetworkInterfaceType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterfaceType#getEntities()
	 * @see #getNetworkInterfaceType()
	 * @generated
	 */
	EReference getNetworkInterfaceType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.NetworkInterfacePerformanceType <em>Network Interface Performance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Network Interface Performance Type</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterfacePerformanceType
	 * @generated
	 */
	EClass getNetworkInterfacePerformanceType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.NetworkInterfacePerformanceType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.NetworkInterfacePerformanceType#getEntities()
	 * @see #getNetworkInterfacePerformanceType()
	 * @generated
	 */
	EReference getNetworkInterfacePerformanceType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.LinkType <em>Link Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link Type</em>'.
	 * @see tools.descartes.dni.dnimm3.LinkType
	 * @generated
	 */
	EClass getLinkType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.LinkType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.LinkType#getEntities()
	 * @see #getLinkType()
	 * @generated
	 */
	EReference getLinkType_Entities();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3.LinkPerformanceType <em>Link Performance Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link Performance Type</em>'.
	 * @see tools.descartes.dni.dnimm3.LinkPerformanceType
	 * @generated
	 */
	EClass getLinkPerformanceType();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3.LinkPerformanceType#getEntities <em>Entities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Entities</em>'.
	 * @see tools.descartes.dni.dnimm3.LinkPerformanceType#getEntities()
	 * @see #getLinkPerformanceType()
	 * @generated
	 */
	EReference getLinkPerformanceType_Entities();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dni.dnimm3.UnitPrefix <em>Unit Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Unit Prefix</em>'.
	 * @see tools.descartes.dni.dnimm3.UnitPrefix
	 * @generated
	 */
	EEnum getUnitPrefix();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dni.dnimm3.Speed <em>Speed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Speed</em>'.
	 * @see tools.descartes.dni.dnimm3.Speed
	 * @generated
	 */
	EEnum getSpeed();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dni.dnimm3.Time <em>Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Time</em>'.
	 * @see tools.descartes.dni.dnimm3.Time
	 * @generated
	 */
	EEnum getTime();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DNIFactory getDNIFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.NamedElement <em>Named Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.NamedElement
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNamedElement()
		 * @generated
		 */
		EClass NAMED_ELEMENT = eINSTANCE.getNamedElement();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NAMED_ELEMENT__NAME = eINSTANCE.getNamedElement_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NAMED_ELEMENT__DESCRIPTION = eINSTANCE.getNamedElement_Description();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.IdentifierImpl <em>Identifier</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.IdentifierImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIdentifier()
		 * @generated
		 */
		EClass IDENTIFIER = eINSTANCE.getIdentifier();

		/**
		 * The meta object literal for the '<em><b>Uid</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IDENTIFIER__UID = eINSTANCE.getIdentifier_Uid();

		/**
		 * The meta object literal for the '<em><b>Uid generated</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IDENTIFIER__UID_GENERATED = eINSTANCE.getIdentifier_Uid_generated();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Entity <em>Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Entity
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEntity()
		 * @generated
		 */
		EClass ENTITY = eINSTANCE.getEntity();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl <em>Network Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInfrastructure()
		 * @generated
		 */
		EClass NETWORK_INFRASTRUCTURE = eINSTANCE.getNetworkInfrastructure();

		/**
		 * The meta object literal for the '<em><b>Traffic</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__TRAFFIC = eINSTANCE.getNetworkInfrastructure_Traffic();

		/**
		 * The meta object literal for the '<em><b>Structure</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__STRUCTURE = eINSTANCE.getNetworkInfrastructure_Structure();

		/**
		 * The meta object literal for the '<em><b>Configuration</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__CONFIGURATION = eINSTANCE.getNetworkInfrastructure_Configuration();

		/**
		 * The meta object literal for the '<em><b>Entity Types</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INFRASTRUCTURE__ENTITY_TYPES = eINSTANCE.getNetworkInfrastructure_EntityTypes();

		/**
		 * The meta object literal for the '<em><b>Data Center Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INFRASTRUCTURE__DATA_CENTER_NAME = eINSTANCE.getNetworkInfrastructure_DataCenterName();

		/**
		 * The meta object literal for the '<em><b>Meta Model Version</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INFRASTRUCTURE__META_MODEL_VERSION = eINSTANCE.getNetworkInfrastructure_MetaModelVersion();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkStructureImpl <em>Network Structure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkStructureImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkStructure()
		 * @generated
		 */
		EClass NETWORK_STRUCTURE = eINSTANCE.getNetworkStructure();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_STRUCTURE__NODES = eINSTANCE.getNetworkStructure_Nodes();

		/**
		 * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_STRUCTURE__LINKS = eINSTANCE.getNetworkStructure_Links();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NodeImpl <em>Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NodeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNode()
		 * @generated
		 */
		EClass NODE = eINSTANCE.getNode();

		/**
		 * The meta object literal for the '<em><b>Interfaces</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__INTERFACES = eINSTANCE.getNode_Interfaces();

		/**
		 * The meta object literal for the '<em><b>Sdntype</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__SDNTYPE = eINSTANCE.getNode_Sdntype();

		/**
		 * The meta object literal for the '<em><b>Is Physical</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NODE__IS_PHYSICAL = eINSTANCE.getNode_IsPhysical();

		/**
		 * The meta object literal for the '<em><b>Is Physical derived</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NODE__IS_PHYSICAL_DERIVED = eINSTANCE.getNode_IsPhysical_derived();

		/**
		 * The meta object literal for the '<em><b>Hosts</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__HOSTS = eINSTANCE.getNode_Hosts();

		/**
		 * The meta object literal for the '<em><b>Is Hosted On</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__IS_HOSTED_ON = eINSTANCE.getNode_IsHostedOn();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__END = eINSTANCE.getNode_End();

		/**
		 * The meta object literal for the '<em><b>Intermediate</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__INTERMEDIATE = eINSTANCE.getNode_Intermediate();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE__ENTITY_TYPE = eINSTANCE.getNode_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.EndImpl <em>End</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.EndImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEnd()
		 * @generated
		 */
		EClass END = eINSTANCE.getEnd();

		/**
		 * The meta object literal for the '<em><b>Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END__PERFORMANCE = eINSTANCE.getEnd_Performance();

		/**
		 * The meta object literal for the '<em><b>Software</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END__SOFTWARE = eINSTANCE.getEnd_Software();

		/**
		 * The meta object literal for the '<em><b>Node</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END__NODE = eINSTANCE.getEnd_Node();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute END__NAME = eINSTANCE.getEnd_Name();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.IntermediateImpl <em>Intermediate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.IntermediateImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIntermediate()
		 * @generated
		 */
		EClass INTERMEDIATE = eINSTANCE.getIntermediate();

		/**
		 * The meta object literal for the '<em><b>Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE__PERFORMANCE = eINSTANCE.getIntermediate_Performance();

		/**
		 * The meta object literal for the '<em><b>Node</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE__NODE = eINSTANCE.getIntermediate_Node();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTERMEDIATE__NAME = eINSTANCE.getIntermediate_Name();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.LinkImpl <em>Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.LinkImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLink()
		 * @generated
		 */
		EClass LINK = eINSTANCE.getLink();

		/**
		 * The meta object literal for the '<em><b>Connects</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__CONNECTS = eINSTANCE.getLink_Connects();

		/**
		 * The meta object literal for the '<em><b>Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__PERFORMANCE = eINSTANCE.getLink_Performance();

		/**
		 * The meta object literal for the '<em><b>Name generated</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__NAME_GENERATED = eINSTANCE.getLink_Name_generated();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__ENTITY_TYPE = eINSTANCE.getLink_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl <em>Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInterface()
		 * @generated
		 */
		EClass NETWORK_INTERFACE = eINSTANCE.getNetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Used Protocol Stack</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE__USED_PROTOCOL_STACK = eINSTANCE.getNetworkInterface_UsedProtocolStack();

		/**
		 * The meta object literal for the '<em><b>Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE__PERFORMANCE = eINSTANCE.getNetworkInterface_Performance();

		/**
		 * The meta object literal for the '<em><b>Node</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE__NODE = eINSTANCE.getNetworkInterface_Node();

		/**
		 * The meta object literal for the '<em><b>Name generated</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_INTERFACE__NAME_GENERATED = eINSTANCE.getNetworkInterface_Name_generated();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE__ENTITY_TYPE = eINSTANCE.getNetworkInterface_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkTrafficImpl <em>Network Traffic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkTrafficImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkTraffic()
		 * @generated
		 */
		EClass NETWORK_TRAFFIC = eINSTANCE.getNetworkTraffic();

		/**
		 * The meta object literal for the '<em><b>Flows</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_TRAFFIC__FLOWS = eINSTANCE.getNetworkTraffic_Flows();

		/**
		 * The meta object literal for the '<em><b>Software</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_TRAFFIC__SOFTWARE = eINSTANCE.getNetworkTraffic_Software();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.FlowImpl <em>Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.FlowImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFlow()
		 * @generated
		 */
		EClass FLOW = eINSTANCE.getFlow();

		/**
		 * The meta object literal for the '<em><b>Source Software</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__SOURCE_SOFTWARE = eINSTANCE.getFlow_SourceSoftware();

		/**
		 * The meta object literal for the '<em><b>Generated Traffic</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__GENERATED_TRAFFIC = eINSTANCE.getFlow_GeneratedTraffic();

		/**
		 * The meta object literal for the '<em><b>Destination Software</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__DESTINATION_SOFTWARE = eINSTANCE.getFlow_DestinationSoftware();

		/**
		 * The meta object literal for the '<em><b>Destination Addresses</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW__DESTINATION_ADDRESSES = eINSTANCE.getFlow_DestinationAddresses();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SdnControlFlowImpl <em>Sdn Control Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SdnControlFlowImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnControlFlow()
		 * @generated
		 */
		EClass SDN_CONTROL_FLOW = eINSTANCE.getSdnControlFlow();

		/**
		 * The meta object literal for the '<em><b>Parent Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_CONTROL_FLOW__PARENT_FLOW = eINSTANCE.getSdnControlFlow_ParentFlow();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.FlowTrafficImpl <em>Flow Traffic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.FlowTrafficImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFlowTraffic()
		 * @generated
		 */
		EClass FLOW_TRAFFIC = eINSTANCE.getFlowTraffic();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_TRAFFIC__FLOW = eINSTANCE.getFlowTraffic_Flow();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLOW_TRAFFIC__NAME = eINSTANCE.getFlowTraffic_Name();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.GenericFlowTrafficImpl <em>Generic Flow Traffic</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.GenericFlowTrafficImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getGenericFlowTraffic()
		 * @generated
		 */
		EClass GENERIC_FLOW_TRAFFIC = eINSTANCE.getGenericFlowTraffic();

		/**
		 * The meta object literal for the '<em><b>Data Size</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_FLOW_TRAFFIC__DATA_SIZE = eINSTANCE.getGenericFlowTraffic_DataSize();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.CommunicatingApplicationImpl <em>Communicating Application</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.CommunicatingApplicationImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getCommunicatingApplication()
		 * @generated
		 */
		EClass COMMUNICATING_APPLICATION = eINSTANCE.getCommunicatingApplication();

		/**
		 * The meta object literal for the '<em><b>Traffic Sources</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMMUNICATING_APPLICATION__TRAFFIC_SOURCES = eINSTANCE.getCommunicatingApplication_TrafficSources();

		/**
		 * The meta object literal for the '<em><b>Deployed On</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMMUNICATING_APPLICATION__DEPLOYED_ON = eINSTANCE.getCommunicatingApplication_DeployedOn();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.TrafficSourceImpl <em>Traffic Source</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.TrafficSourceImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTrafficSource()
		 * @generated
		 */
		EClass TRAFFIC_SOURCE = eINSTANCE.getTrafficSource();

		/**
		 * The meta object literal for the '<em><b>Workload</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRAFFIC_SOURCE__WORKLOAD = eINSTANCE.getTrafficSource_Workload();

		/**
		 * The meta object literal for the '<em><b>Software Component</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRAFFIC_SOURCE__SOFTWARE_COMPONENT = eINSTANCE.getTrafficSource_SoftwareComponent();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkConfigurationImpl <em>Network Configuration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkConfigurationImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkConfiguration()
		 * @generated
		 */
		EClass NETWORK_CONFIGURATION = eINSTANCE.getNetworkConfiguration();

		/**
		 * The meta object literal for the '<em><b>Protocols And Stacks</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_CONFIGURATION__PROTOCOLS_AND_STACKS = eINSTANCE.getNetworkConfiguration_ProtocolsAndStacks();

		/**
		 * The meta object literal for the '<em><b>Routes</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_CONFIGURATION__ROUTES = eINSTANCE.getNetworkConfiguration_Routes();

		/**
		 * The meta object literal for the '<em><b>Rules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_CONFIGURATION__RULES = eINSTANCE.getNetworkConfiguration_Rules();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.ProtocolsRepositoryImpl <em>Protocols Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.ProtocolsRepositoryImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getProtocolsRepository()
		 * @generated
		 */
		EClass PROTOCOLS_REPOSITORY = eINSTANCE.getProtocolsRepository();

		/**
		 * The meta object literal for the '<em><b>Stacks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOLS_REPOSITORY__STACKS = eINSTANCE.getProtocolsRepository_Stacks();

		/**
		 * The meta object literal for the '<em><b>Protocols</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOLS_REPOSITORY__PROTOCOLS = eINSTANCE.getProtocolsRepository_Protocols();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.ProtocolStackImpl <em>Protocol Stack</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.ProtocolStackImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getProtocolStack()
		 * @generated
		 */
		EClass PROTOCOL_STACK = eINSTANCE.getProtocolStack();

		/**
		 * The meta object literal for the '<em><b>Layers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_STACK__LAYERS = eINSTANCE.getProtocolStack_Layers();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.ProtocolLayerImpl <em>Protocol Layer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.ProtocolLayerImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getProtocolLayer()
		 * @generated
		 */
		EClass PROTOCOL_LAYER = eINSTANCE.getProtocolLayer();

		/**
		 * The meta object literal for the '<em><b>Protocol</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_LAYER__PROTOCOL = eINSTANCE.getProtocolLayer_Protocol();

		/**
		 * The meta object literal for the '<em><b>Is Carried By</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_LAYER__IS_CARRIED_BY = eINSTANCE.getProtocolLayer_IsCarriedBy();

		/**
		 * The meta object literal for the '<em><b>Carries</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROTOCOL_LAYER__CARRIES = eINSTANCE.getProtocolLayer_Carries();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkProtocolImpl <em>Network Protocol</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkProtocolImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkProtocol()
		 * @generated
		 */
		EClass NETWORK_PROTOCOL = eINSTANCE.getNetworkProtocol();

		/**
		 * The meta object literal for the '<em><b>Mtu</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__MTU = eINSTANCE.getNetworkProtocol_Mtu();

		/**
		 * The meta object literal for the '<em><b>Headers Length</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK_PROTOCOL__HEADERS_LENGTH = eINSTANCE.getNetworkProtocol_HeadersLength();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.RoutesRepositoryImpl <em>Routes Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.RoutesRepositoryImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getRoutesRepository()
		 * @generated
		 */
		EClass ROUTES_REPOSITORY = eINSTANCE.getRoutesRepository();

		/**
		 * The meta object literal for the '<em><b>Routes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTES_REPOSITORY__ROUTES = eINSTANCE.getRoutesRepository_Routes();

		/**
		 * The meta object literal for the '<em><b>Flow Routes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTES_REPOSITORY__FLOW_ROUTES = eINSTANCE.getRoutesRepository_FlowRoutes();

		/**
		 * The meta object literal for the '<em><b>Directions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTES_REPOSITORY__DIRECTIONS = eINSTANCE.getRoutesRepository_Directions();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.DirectionImpl <em>Direction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.DirectionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDirection()
		 * @generated
		 */
		EClass DIRECTION = eINSTANCE.getDirection();

		/**
		 * The meta object literal for the '<em><b>On Node</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DIRECTION__ON_NODE = eINSTANCE.getDirection_OnNode();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DIRECTION__FLOW = eINSTANCE.getDirection_Flow();

		/**
		 * The meta object literal for the '<em><b>Via</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DIRECTION__VIA = eINSTANCE.getDirection_Via();

		/**
		 * The meta object literal for the '<em><b>Default</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DIRECTION__DEFAULT = eINSTANCE.getDirection_Default();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DIRECTION__PROBABILITY = eINSTANCE.getDirection_Probability();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.FlowRouteImpl <em>Flow Route</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.FlowRouteImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFlowRoute()
		 * @generated
		 */
		EClass FLOW_ROUTE = eINSTANCE.getFlowRoute();

		/**
		 * The meta object literal for the '<em><b>Hops</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__HOPS = eINSTANCE.getFlowRoute_Hops();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__FLOW = eINSTANCE.getFlowRoute_Flow();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__START = eINSTANCE.getFlowRoute_Start();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FLOW_ROUTE__END = eINSTANCE.getFlowRoute_End();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLOW_ROUTE__PROBABILITY = eINSTANCE.getFlowRoute_Probability();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.RouteImpl <em>Route</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.RouteImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getRoute()
		 * @generated
		 */
		EClass ROUTE = eINSTANCE.getRoute();

		/**
		 * The meta object literal for the '<em><b>Hops</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTE__HOPS = eINSTANCE.getRoute_Hops();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTE__START = eINSTANCE.getRoute_Start();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROUTE__END = eINSTANCE.getRoute_End();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.HopImpl <em>Hop</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.HopImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getHop()
		 * @generated
		 */
		EClass HOP = eINSTANCE.getHop();

		/**
		 * The meta object literal for the '<em><b>Next Hop</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOP__NEXT_HOP = eINSTANCE.getHop_NextHop();

		/**
		 * The meta object literal for the '<em><b>Interfaceref</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HOP__INTERFACEREF = eINSTANCE.getHop_Interfaceref();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.EntityAddressImpl <em>Entity Address</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.EntityAddressImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEntityAddress()
		 * @generated
		 */
		EClass ENTITY_ADDRESS = eINSTANCE.getEntityAddress();

		/**
		 * The meta object literal for the '<em><b>Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY_ADDRESS__ADDRESS = eINSTANCE.getEntityAddress_Address();

		/**
		 * The meta object literal for the '<em><b>Address Given By</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_ADDRESS__ADDRESS_GIVEN_BY = eINSTANCE.getEntityAddress_AddressGivenBy();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.AddressableEntity <em>Addressable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.AddressableEntity
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getAddressableEntity()
		 * @generated
		 */
		EClass ADDRESSABLE_ENTITY = eINSTANCE.getAddressableEntity();

		/**
		 * The meta object literal for the '<em><b>Addresses</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADDRESSABLE_ENTITY__ADDRESSES = eINSTANCE.getAddressableEntity_Addresses();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Workload <em>Workload</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Workload
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getWorkload()
		 * @generated
		 */
		EClass WORKLOAD = eINSTANCE.getWorkload();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.GenericWorkloadImpl <em>Generic Workload</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.GenericWorkloadImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getGenericWorkload()
		 * @generated
		 */
		EClass GENERIC_WORKLOAD = eINSTANCE.getGenericWorkload();

		/**
		 * The meta object literal for the '<em><b>Actions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_WORKLOAD__ACTIONS = eINSTANCE.getGenericWorkload_Actions();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.AbstractAction <em>Abstract Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.AbstractAction
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getAbstractAction()
		 * @generated
		 */
		EClass ABSTRACT_ACTION = eINSTANCE.getAbstractAction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.BranchActionImpl <em>Branch Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.BranchActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getBranchAction()
		 * @generated
		 */
		EClass BRANCH_ACTION = eINSTANCE.getBranchAction();

		/**
		 * The meta object literal for the '<em><b>Intern</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCH_ACTION__INTERN = eINSTANCE.getBranchAction_Intern();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.LoopActionImpl <em>Loop Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.LoopActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLoopAction()
		 * @generated
		 */
		EClass LOOP_ACTION = eINSTANCE.getLoopAction();

		/**
		 * The meta object literal for the '<em><b>Intern</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_ACTION__INTERN = eINSTANCE.getLoopAction_Intern();

		/**
		 * The meta object literal for the '<em><b>Num Iterations</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_ACTION__NUM_ITERATIONS = eINSTANCE.getLoopAction_NumIterations();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SequenceActionImpl <em>Sequence Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SequenceActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSequenceAction()
		 * @generated
		 */
		EClass SEQUENCE_ACTION = eINSTANCE.getSequenceAction();

		/**
		 * The meta object literal for the '<em><b>Intern</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEQUENCE_ACTION__INTERN = eINSTANCE.getSequenceAction_Intern();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.StartActionImpl <em>Start Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.StartActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getStartAction()
		 * @generated
		 */
		EClass START_ACTION = eINSTANCE.getStartAction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.StopActionImpl <em>Stop Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.StopActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getStopAction()
		 * @generated
		 */
		EClass STOP_ACTION = eINSTANCE.getStopAction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.TransmitActionImpl <em>Transmit Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.TransmitActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTransmitAction()
		 * @generated
		 */
		EClass TRANSMIT_ACTION = eINSTANCE.getTransmitAction();

		/**
		 * The meta object literal for the '<em><b>Flow Traffic</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRANSMIT_ACTION__FLOW_TRAFFIC = eINSTANCE.getTransmitAction_FlowTraffic();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.WaitActionImpl <em>Wait Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.WaitActionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getWaitAction()
		 * @generated
		 */
		EClass WAIT_ACTION = eINSTANCE.getWaitAction();

		/**
		 * The meta object literal for the '<em><b>Wait Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WAIT_ACTION__WAIT_TIME = eINSTANCE.getWaitAction_WaitTime();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.PerformanceSpecification <em>Performance Specification</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.PerformanceSpecification
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceSpecification()
		 * @generated
		 */
		EClass PERFORMANCE_SPECIFICATION = eINSTANCE.getPerformanceSpecification();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.PerformanceLinkImpl <em>Performance Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.PerformanceLinkImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceLink()
		 * @generated
		 */
		EClass PERFORMANCE_LINK = eINSTANCE.getPerformanceLink();

		/**
		 * The meta object literal for the '<em><b>Propagation Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_LINK__PROPAGATION_DELAY = eINSTANCE.getPerformanceLink_PropagationDelay();

		/**
		 * The meta object literal for the '<em><b>Max Supported Bandwidth</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_LINK__MAX_SUPPORTED_BANDWIDTH = eINSTANCE.getPerformanceLink_MaxSupportedBandwidth();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_LINK__ENTITY_TYPE = eINSTANCE.getPerformanceLink_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.PerformanceNetworkInterfaceImpl <em>Performance Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.PerformanceNetworkInterfaceImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceNetworkInterface()
		 * @generated
		 */
		EClass PERFORMANCE_NETWORK_INTERFACE = eINSTANCE.getPerformanceNetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Is Up</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PERFORMANCE_NETWORK_INTERFACE__IS_UP = eINSTANCE.getPerformanceNetworkInterface_IsUp();

		/**
		 * The meta object literal for the '<em><b>MTU</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PERFORMANCE_NETWORK_INTERFACE__MTU = eINSTANCE.getPerformanceNetworkInterface_MTU();

		/**
		 * The meta object literal for the '<em><b>Packet Processing Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME = eINSTANCE.getPerformanceNetworkInterface_PacketProcessingTime();

		/**
		 * The meta object literal for the '<em><b>Interface Throughput</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT = eINSTANCE.getPerformanceNetworkInterface_InterfaceThroughput();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_NETWORK_INTERFACE__ENTITY_TYPE = eINSTANCE.getPerformanceNetworkInterface_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SdnFlowRuleImpl <em>Sdn Flow Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SdnFlowRuleImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnFlowRule()
		 * @generated
		 */
		EClass SDN_FLOW_RULE = eINSTANCE.getSdnFlowRule();

		/**
		 * The meta object literal for the '<em><b>Sdn Switch</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_FLOW_RULE__SDN_SWITCH = eINSTANCE.getSdnFlowRule_SdnSwitch();

		/**
		 * The meta object literal for the '<em><b>Flow</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_FLOW_RULE__FLOW = eINSTANCE.getSdnFlowRule_Flow();

		/**
		 * The meta object literal for the '<em><b>Probability Hardware</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDN_FLOW_RULE__PROBABILITY_HARDWARE = eINSTANCE.getSdnFlowRule_ProbabilityHardware();

		/**
		 * The meta object literal for the '<em><b>Probability Software</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDN_FLOW_RULE__PROBABILITY_SOFTWARE = eINSTANCE.getSdnFlowRule_ProbabilitySoftware();

		/**
		 * The meta object literal for the '<em><b>Probability Controller</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDN_FLOW_RULE__PROBABILITY_CONTROLLER = eINSTANCE.getSdnFlowRule_ProbabilityController();

		/**
		 * The meta object literal for the '<em><b>Controller Application</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_FLOW_RULE__CONTROLLER_APPLICATION = eINSTANCE.getSdnFlowRule_ControllerApplication();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SdnControllerImpl <em>Sdn Controller</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SdnControllerImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnController()
		 * @generated
		 */
		EClass SDN_CONTROLLER = eINSTANCE.getSdnController();

		/**
		 * The meta object literal for the '<em><b>Applications</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_CONTROLLER__APPLICATIONS = eINSTANCE.getSdnController_Applications();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_CONTROLLER__NODES = eINSTANCE.getSdnController_Nodes();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SdnControllerApplicationImpl <em>Sdn Controller Application</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SdnControllerApplicationImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnControllerApplication()
		 * @generated
		 */
		EClass SDN_CONTROLLER_APPLICATION = eINSTANCE.getSdnControllerApplication();

		/**
		 * The meta object literal for the '<em><b>Belongs To</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_CONTROLLER_APPLICATION__BELONGS_TO = eINSTANCE.getSdnControllerApplication_BelongsTo();

		/**
		 * The meta object literal for the '<em><b>Is Default</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDN_CONTROLLER_APPLICATION__IS_DEFAULT = eINSTANCE.getSdnControllerApplication_IsDefault();

		/**
		 * The meta object literal for the '<em><b>Response Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_CONTROLLER_APPLICATION__RESPONSE_DELAY = eINSTANCE.getSdnControllerApplication_ResponseDelay();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.IType <em>IType</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.IType
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIType()
		 * @generated
		 */
		EClass ITYPE = eINSTANCE.getIType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.CommonImpl <em>Common</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.CommonImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getCommon()
		 * @generated
		 */
		EClass COMMON = eINSTANCE.getCommon();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SDNImpl <em>SDN</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SDNImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSDN()
		 * @generated
		 */
		EClass SDN = eINSTANCE.getSDN();

		/**
		 * The meta object literal for the '<em><b>Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN__PERFORMANCE = eINSTANCE.getSDN_Performance();

		/**
		 * The meta object literal for the '<em><b>Controller</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN__CONTROLLER = eINSTANCE.getSDN_Controller();

		/**
		 * The meta object literal for the '<em><b>Open Flow End Point</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN__OPEN_FLOW_END_POINT = eINSTANCE.getSDN_OpenFlowEndPoint();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.IntermediatePerformanceImpl <em>Intermediate Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.IntermediatePerformanceImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIntermediatePerformance()
		 * @generated
		 */
		EClass INTERMEDIATE_PERFORMANCE = eINSTANCE.getIntermediatePerformance();

		/**
		 * The meta object literal for the '<em><b>Forwarding Latency</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY = eINSTANCE.getIntermediatePerformance_ForwardingLatency();

		/**
		 * The meta object literal for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS = eINSTANCE.getIntermediatePerformance_ForwardingBandwidthBPS();

		/**
		 * The meta object literal for the '<em><b>Switching Capacity PPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS = eINSTANCE.getIntermediatePerformance_SwitchingCapacityPPS();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_PERFORMANCE__ENTITY_TYPE = eINSTANCE.getIntermediatePerformance_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.EndPerformanceImpl <em>End Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.EndPerformanceImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEndPerformance()
		 * @generated
		 */
		EClass END_PERFORMANCE = eINSTANCE.getEndPerformance();

		/**
		 * The meta object literal for the '<em><b>Software Layers Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END_PERFORMANCE__SOFTWARE_LAYERS_DELAY = eINSTANCE.getEndPerformance_SoftwareLayersDelay();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END_PERFORMANCE__ENTITY_TYPE = eINSTANCE.getEndPerformance_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.PerformanceSdnNodeImpl <em>Performance Sdn Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.PerformanceSdnNodeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getPerformanceSdnNode()
		 * @generated
		 */
		EClass PERFORMANCE_SDN_NODE = eINSTANCE.getPerformanceSdnNode();

		/**
		 * The meta object literal for the '<em><b>Software Switching Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_SDN_NODE__SOFTWARE_SWITCHING_PERFORMANCE = eINSTANCE.getPerformanceSdnNode_SoftwareSwitchingPerformance();

		/**
		 * The meta object literal for the '<em><b>Hardware Switching Performance</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_SDN_NODE__HARDWARE_SWITCHING_PERFORMANCE = eINSTANCE.getPerformanceSdnNode_HardwareSwitchingPerformance();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERFORMANCE_SDN_NODE__ENTITY_TYPE = eINSTANCE.getPerformanceSdnNode_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.DNIUnit <em>Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.DNIUnit
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDNIUnit()
		 * @generated
		 */
		EClass DNI_UNIT = eINSTANCE.getDNIUnit();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SpeedUnitImpl <em>Speed Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SpeedUnitImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSpeedUnit()
		 * @generated
		 */
		EClass SPEED_UNIT = eINSTANCE.getSpeedUnit();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SPEED_UNIT__UNIT = eINSTANCE.getSpeedUnit_Unit();

		/**
		 * The meta object literal for the '<em><b>Prefix</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SPEED_UNIT__PREFIX = eINSTANCE.getSpeedUnit_Prefix();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.DataUnitImpl <em>Data Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.DataUnitImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDataUnit()
		 * @generated
		 */
		EClass DATA_UNIT = eINSTANCE.getDataUnit();

		/**
		 * The meta object literal for the '<em><b>Prefix</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_UNIT__PREFIX = eINSTANCE.getDataUnit_Prefix();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.TimeUnitImpl <em>Time Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.TimeUnitImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTimeUnit()
		 * @generated
		 */
		EClass TIME_UNIT = eINSTANCE.getTimeUnit();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TIME_UNIT__UNIT = eINSTANCE.getTimeUnit_Unit();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Dependency <em>Dependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Dependency
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDependency()
		 * @generated
		 */
		EClass DEPENDENCY = eINSTANCE.getDependency();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY__UNIT = eINSTANCE.getDependency_Unit();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Variable <em>Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Variable
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getVariable()
		 * @generated
		 */
		EClass VARIABLE = eINSTANCE.getVariable();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Function <em>Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Function
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFunction()
		 * @generated
		 */
		EClass FUNCTION = eINSTANCE.getFunction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.ConstantDoubleVariableImpl <em>Constant Double Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.ConstantDoubleVariableImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getConstantDoubleVariable()
		 * @generated
		 */
		EClass CONSTANT_DOUBLE_VARIABLE = eINSTANCE.getConstantDoubleVariable();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTANT_DOUBLE_VARIABLE__VALUE = eINSTANCE.getConstantDoubleVariable_Value();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.ConstantLongVariableImpl <em>Constant Long Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.ConstantLongVariableImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getConstantLongVariable()
		 * @generated
		 */
		EClass CONSTANT_LONG_VARIABLE = eINSTANCE.getConstantLongVariable();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTANT_LONG_VARIABLE__VALUE = eINSTANCE.getConstantLongVariable_Value();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.RandomVariableImpl <em>Random Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.RandomVariableImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getRandomVariable()
		 * @generated
		 */
		EClass RANDOM_VARIABLE = eINSTANCE.getRandomVariable();

		/**
		 * The meta object literal for the '<em><b>Cdf</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_VARIABLE__CDF = eINSTANCE.getRandomVariable_Cdf();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.FloatCoordinateImpl <em>Float Coordinate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.FloatCoordinateImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getFloatCoordinate()
		 * @generated
		 */
		EClass FLOAT_COORDINATE = eINSTANCE.getFloatCoordinate();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLOAT_COORDINATE__X = eINSTANCE.getFloatCoordinate_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FLOAT_COORDINATE__Y = eINSTANCE.getFloatCoordinate_Y();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.DiscreteFunctionImpl <em>Discrete Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.DiscreteFunctionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getDiscreteFunction()
		 * @generated
		 */
		EClass DISCRETE_FUNCTION = eINSTANCE.getDiscreteFunction();

		/**
		 * The meta object literal for the '<em><b>Vals</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DISCRETE_FUNCTION__VALS = eINSTANCE.getDiscreteFunction_Vals();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.ExponentialFunctionImpl <em>Exponential Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.ExponentialFunctionImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getExponentialFunction()
		 * @generated
		 */
		EClass EXPONENTIAL_FUNCTION = eINSTANCE.getExponentialFunction();

		/**
		 * The meta object literal for the '<em><b>Lambda</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPONENTIAL_FUNCTION__LAMBDA = eINSTANCE.getExponentialFunction_Lambda();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.EntityTypesImpl <em>Entity Types</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.EntityTypesImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEntityTypes()
		 * @generated
		 */
		EClass ENTITY_TYPES = eINSTANCE.getEntityTypes();

		/**
		 * The meta object literal for the '<em><b>Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY_TYPES__TYPES = eINSTANCE.getEntityTypes_Types();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.ITypedEntity <em>ITyped Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.ITypedEntity
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getITypedEntity()
		 * @generated
		 */
		EClass ITYPED_ENTITY = eINSTANCE.getITypedEntity();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NodeTypeImpl <em>Node Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NodeTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNodeType()
		 * @generated
		 */
		EClass NODE_TYPE = eINSTANCE.getNodeType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE_TYPE__ENTITIES = eINSTANCE.getNodeType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.EndPerformanceTypeImpl <em>End Performance Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.EndPerformanceTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getEndPerformanceType()
		 * @generated
		 */
		EClass END_PERFORMANCE_TYPE = eINSTANCE.getEndPerformanceType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference END_PERFORMANCE_TYPE__ENTITIES = eINSTANCE.getEndPerformanceType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.IntermediatePerformanceTypeImpl <em>Intermediate Performance Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.IntermediatePerformanceTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getIntermediatePerformanceType()
		 * @generated
		 */
		EClass INTERMEDIATE_PERFORMANCE_TYPE = eINSTANCE.getIntermediatePerformanceType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERMEDIATE_PERFORMANCE_TYPE__ENTITIES = eINSTANCE.getIntermediatePerformanceType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.SdnNodePerformanceTypeImpl <em>Sdn Node Performance Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.SdnNodePerformanceTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSdnNodePerformanceType()
		 * @generated
		 */
		EClass SDN_NODE_PERFORMANCE_TYPE = eINSTANCE.getSdnNodePerformanceType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SDN_NODE_PERFORMANCE_TYPE__ENTITIES = eINSTANCE.getSdnNodePerformanceType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceTypeImpl <em>Network Interface Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkInterfaceTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInterfaceType()
		 * @generated
		 */
		EClass NETWORK_INTERFACE_TYPE = eINSTANCE.getNetworkInterfaceType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE_TYPE__ENTITIES = eINSTANCE.getNetworkInterfaceType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.NetworkInterfacePerformanceTypeImpl <em>Network Interface Performance Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.NetworkInterfacePerformanceTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getNetworkInterfacePerformanceType()
		 * @generated
		 */
		EClass NETWORK_INTERFACE_PERFORMANCE_TYPE = eINSTANCE.getNetworkInterfacePerformanceType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NETWORK_INTERFACE_PERFORMANCE_TYPE__ENTITIES = eINSTANCE.getNetworkInterfacePerformanceType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.LinkTypeImpl <em>Link Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.LinkTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLinkType()
		 * @generated
		 */
		EClass LINK_TYPE = eINSTANCE.getLinkType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_TYPE__ENTITIES = eINSTANCE.getLinkType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.impl.LinkPerformanceTypeImpl <em>Link Performance Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.impl.LinkPerformanceTypeImpl
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getLinkPerformanceType()
		 * @generated
		 */
		EClass LINK_PERFORMANCE_TYPE = eINSTANCE.getLinkPerformanceType();

		/**
		 * The meta object literal for the '<em><b>Entities</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_PERFORMANCE_TYPE__ENTITIES = eINSTANCE.getLinkPerformanceType_Entities();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.UnitPrefix <em>Unit Prefix</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.UnitPrefix
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getUnitPrefix()
		 * @generated
		 */
		EEnum UNIT_PREFIX = eINSTANCE.getUnitPrefix();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Speed <em>Speed</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Speed
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getSpeed()
		 * @generated
		 */
		EEnum SPEED = eINSTANCE.getSpeed();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3.Time <em>Time</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3.Time
		 * @see tools.descartes.dni.dnimm3.impl.DNIPackageImpl#getTime()
		 * @generated
		 */
		EEnum TIME = eINSTANCE.getTime();

	}

} //DNIPackage
